<?

class CodeParser {

 var $baseObj;
 var $showErrors;
 var $evaluate;
 var $editMode;
 var $handleDeps;
 
 function CodeParser(&$baseObj, $showErrors, $evaluate, $editMode=CN_EM_PUBLISH, $handleDeps = true) {
 $this->baseObj =& $baseObj;
 $this->showErrors = $showErrors;
 $this->evaluate = $evaluate;
 $this->editMode = $editMode;
 $this->handleDeps = $handleDeps;
 }
 
 function parse($source) {
 
 $javaParser =& $this->getJavaParser();
 $source = $javaParser->parse($this->baseObj, $source, $this->showErrors, $this->evaluate, $this->editMode, $this->handleDeps);

 return $source;
 }

 function render($versionTimestamp = -1) {

 $javaParser =& $this->getJavaParser();
 $source = $javaParser->render($this->baseObj, $this->showErrors, $this->evaluate, $this->editMode, $this->handleDeps, false, -1, false, $versionTimestamp );

 return $source;
 }

 function diff($versionTimestamp, $diffTimestamp, $showSource = false) {
 $javaParser =& $this->getJavaParser();
 return $javaParser->diff($this->baseObj, $this->showErrors, $this->evaluate, $this->editMode, $this->handleDeps, false, -1, false, $versionTimestamp, $diffTimestamp, $showSource);
 }

 function renderTagIds() {
 
 $javaParser =& $this->getJavaParser();
 $source = $javaParser->render($this->baseObj, $this->showErrors, $this->evaluate, $this->editMode, $this->handleDeps, false, -1, true);

 return $source;
 }
 
 function &getJavaParser() {
 static $parser = null;
 if ($parser === null) {
 $parser = new JavaParser("pn3");
 if (!$parser->isConnected()) {
 $parser->initConnection();
 }
 }
 return $parser;
 }



 


 function getInlineEditableTags() {
 global $JAVAPARSER_RETURN, $JS;
 
 
 while(list($k, $v) = each($JAVAPARSER_RETURN["params"])) {
 if ($k == "gentics.JS") {
 
 $JS .= $v[0];
 } else {
 $INPAGEEDIT_TAGS[$k]["construct_id"] = $v[0];
 for ($index = 1; $index < sizeof($v); $index++) {
 $INPAGEEDIT_TAGS[$k][$v[$index]] = true;
 }
 }
 }
 return $INPAGEEDIT_TAGS;
 }
}






class JavaParser {

 var $connectName;
 var $connect;

 var $portlet;

 var $errors;

 var $eventTriggered = false;

 var $logTriggered;

 var $bufferedClearCaches = array();

 var $doBufferClearCaches = false;

 var $bufferClearCachesThreshold = 100;

 var $bufferedEvents = array();

 var $doBufferEvents = false;

 var $bufferEventsThreshold = 40;

 function JavaParser($connectName) {
 global $PORTAL_CONNECT;
 
 $this->connectName = $connectName;
 $this->errors = array();
 $this->portlet = $PORTAL_CONNECT["portlet"];
 $this->_loadConnection();
 }

 function setPortalUrl($url) {
 $this->connect->setPortalUrl($url);
 }

 function getPortalUrl() {
 return $this->connect->getPortalUrl();
 }
 
 


 function setPortlet($portlet) {
 $this->portlet = $portlet;
 }

 function initConnection() {
 

 $this->connect->connect();
 }

 function isConnected() {
 return $this->connect->isConnected();
 }

 function disconnect() {
 $this->connect->disconnect();
 }
 
 function parse(&$baseObj, $source, $showErrors, $evaluate, $editMode, $handleDeps = true) {
 global $SESSION_TOKEN, $LINKWAY, $T_TEMPLATE, $FOLDER_ID, $HTTP_USER_AGENT, $LANGUAGE;
 
 $params = array();
 $params["action"] = "parse";
 $params["objType"] = $baseObj->getTType();
 $params["objId"] = $baseObj->getID();
 if ($params["objType"] == $T_TEMPLATE) {
 $params["folderId"] = $FOLDER_ID;
 }
 $params["showErrors"] = $showErrors ? "TRUE" : "FALSE" ;
 $params["evaluate"] = $evaluate ? "TRUE" : "FALSE" ;
 $params["handleDependencies"] = $handleDeps ? "TRUE" : "FALSE" ;
 $params["cnSessionId"] = $SESSION_TOKEN;
 $params["linkWay"] = "";
 $params["editMode"] = $this->getEditMode($editMode);
 $params["httpUserAgent"] = $HTTP_USER_AGENT;
 $params["language"] = $LANGUAGE;

 
 $params["template"] = $source;

 $rs = $this->_query($params);
 
 return $rs;
 }

 function render(&$baseObj, $showErrors, $evaluate, $editMode, $handleDeps = true, $simulate = false, $dependencyId = -1, $tagids = false, $versionTimestamp = -1) {
 global $SESSION_TOKEN, $LINKWAY, $HTTP_USER_AGENT, $LANGUAGE, $DEBUG, $T_TEMPLATE, $FOLDER_ID, $NODE_ID;
 
 $params = array();
 $params["action"] = "render";
 $params["objType"] = $baseObj->getTType();
 if ($params["objType"] == $T_TEMPLATE) {
 $params["folderId"] = $FOLDER_ID;
 }
 $params["objId"] = $baseObj->getID();
 $params["showErrors"] = $showErrors ? "TRUE" : "FALSE" ;
 $params["evaluate"] = $evaluate ? "TRUE" : "FALSE" ;
 $params["handleDependencies"] = $handleDeps ? "TRUE" : "FALSE" ;
 $params["cnSessionId"] = $SESSION_TOKEN;
 $params["linkWay"] = "";
 $params["editMode"] = $this->getEditMode($editMode);
 $params["httpUserAgent"] = $HTTP_USER_AGENT;
 $params["language"] = $LANGUAGE;
 $params["debugPublish"] = $DEBUG["publish"] && ($editMode == CN_EM_LIVE || $editMode == CN_EM_PREVIEW) ? "TRUE" : "FALSE";
 $params["simulate"] = $simulate ? "TRUE" : "FALSE";
 $params["dependencyId"] = $dependencyId;
 $params["renderTagIds"] = $tagids ? "TRUE" : "FALSE";
 $params["versionTimestamp"] = $versionTimestamp;
 $params["nodeId"] = $NODE_ID;

 $rs = $this->_query($params);

 return $rs;
 }

 function diff(&$baseObj, $showErrors, $evaluate, $editMode, $handleDeps = true, $simulate = false, $dependencyId = -1, $tagids = false, $versionTimestamp = -1, $diffTimestamp = -1, $diffSource = false) {
 global $SESSION_TOKEN, $LINKWAY, $HTTP_USER_AGENT, $LANGUAGE, $DEBUG, $T_TEMPLATE, $FOLDER_ID;
 
 $params = array();
 $params["action"] = "diff";
 $params["objType"] = $baseObj->getTType();
 if ($params["objType"] == $T_TEMPLATE) {
 $params["folderId"] = $FOLDER_ID;
 }
 $params["objId"] = $baseObj->getID();
 $params["showErrors"] = $showErrors ? "TRUE" : "FALSE" ;
 $params["evaluate"] = $evaluate ? "TRUE" : "FALSE" ;
 $params["handleDependencies"] = $handleDeps ? "TRUE" : "FALSE" ;
 $params["cnSessionId"] = $SESSION_TOKEN;
 $params["linkWay"] = "";
 $params["editMode"] = $this->getEditMode($editMode);
 $params["httpUserAgent"] = $HTTP_USER_AGENT;
 $params["language"] = $LANGUAGE;
 $params["debugPublish"] = $DEBUG["publish"] && ($editMode == CN_EM_LIVE || $editMode == CN_EM_PREVIEW) ? "TRUE" : "FALSE";
 $params["simulate"] = $simulate ? "TRUE" : "FALSE";
 $params["dependencyId"] = $dependencyId;
 $params["renderTagIds"] = $tagids ? "TRUE" : "FALSE";
 $params["versionTimestamp"] = $versionTimestamp;
 $params["diffTimestamp"] = $diffTimestamp;
 $params["diffSource"] = $diffSource ? "TRUE" : "FALSE";

 $rs = $this->_query($params);

 return $rs;
 }


 function clearCache($objType = "", $objId = "") {
 if ($this->doBufferClearCaches) {
 $tocache = $objType.".".$objId;
 if (!in_array($tocache, $this->bufferedClearCaches)) {
 $this->bufferedClearCaches[] = $tocache;
 if (count($this->bufferedClearCaches) > $this->bufferClearCachesThreshold) {
 $this->flushClearCaches();
 }
 }
 } else {
 $params = array();
 $params["action"] = "clearcache";
 $params["objType"] = $objType;
 $params["objId"] = $objId;
 
 $rs = $this->_query($params);
 
 return $rs;
 }
 }

 






 function deleteObject($objType = "", $objId = "", $foregroundTime = null) {
 global $SESSION_TOKEN, $LANGUAGE, $USER_ID, $PHPSHELL;
 $params = array();
 $params["action"] = "deleteObject";
 $params["objType"] = $objType;

 if (is_array($objId)) {
 $params["objId"] = implode(",", $objId);
 } else {
 $params["objId"] = $objId;
 }
 $params["cnSessionId"] = $SESSION_TOKEN;
 
 if ($PHPSHELL) {
 $params["cnUserId"] = $USER_ID;
 }
 $params["language"] = $LANGUAGE;

 if ($foregroundTime) {
 $params["foregroundTime"] = $foregroundTime;
 }

 $rs = $this->_query($params);
 
 return $rs;
 }

 





 function changeTemplate($objId, $templateId, $syncTags) {
 global $SESSION_TOKEN, $LANGUAGE, $USER_ID, $PHPSHELL;

 $params = array();
 $params["action"] = "changeTemplate";
 $params["templateId"] = $templateId;
 $params["syncTags"] = $syncTags;
 if (is_array($objId)) {
 $params["objId"] = implode(",", $objId);
 } else {
 $params["objId"] = $objId;
 }

 $params["cnSessionId"] = $SESSION_TOKEN;
 
 if ($PHPSHELL) {
 $params["cnUserId"] = $USER_ID;
 }
 $params["language"] = $LANGUAGE;

 $rs = $this->_query($params);

 return $rs;
 }

 





 function unlinkTemplate($ids, $folder_ids) {
 global $SESSION_TOKEN, $LANGUAGE;
 $params = array();
 $params["action"] = "unlinkTemplate";
 if (is_array($ids)) {
 $params["templateId"] = implode(",", $ids);
 } else {
 $params["templateId"] = $ids;
 }
 if (is_array($folder_ids)) {
 $params["folderId"] = implode(",", $folder_ids);
 } else {
 $params["folderId"] = $folder_ids;
 }
 $params["cnSessionId"] = $SESSION_TOKEN;
 $params["language"] = $LANGUAGE;

 return $this->_query($params);
 }

 function triggerEvent($TType, $id, $property, $events = EVENT_ALL, $simulate = 0) {
 global $DISABLE_DIRT, $SESSION_TOKEN, $FEATURE, $LASTEDITLOG;
 if ($DISABLE_DIRT) {
 return;
 }

 $params = array();
 $params["action"] = "trigger";
 $params["sid"] = $SESSION_TOKEN;
 if ($FEATURE["log_dirt_events"]) {
 if (!$this->eventTriggered) {
 
 $params["events"] = EVENT_LOGGING_START;
 $params["objId"] = $LASTEDITLOG;
 $rs = $this->_internalTriggerEvent($params);
 $this->eventTriggered = true;
 $this->logTriggered = $LASTEDITLOG;
 } else if ($this->logTriggered != $LASTEDITLOG) {
 
 $params["events"] = EVENT_LOGGING_END;
 $rs = $this->_internalTriggerEvent($params);
 
 $params["events"] = EVENT_LOGGING_START;
 $params["objId"] = $LASTEDITLOG;
 $rs = $this->_internalTriggerEvent($params);
 $this->logTriggered = $LASTEDITLOG;
 }
 }
 
 $params["objType"] = $TType;
 $params["objId"] = $id;
 $params["property"] = is_array($property) ? implode(",", $property) : $property;
 if ($simulate != 0) {
 $params["simulate"] = $simulate;
 }

 
 $params["events"] = $events;

 $rs = $this->_internalTriggerEvent($params);

 return $rs;
 }

 function _internalTriggerEvent($params) {
 if ($this->doBufferEvents) {
 unset($params["action"]);
 unset($params["sid"]);
 $this->bufferedEvents[] = $params;
 if (count($this->bufferedEvents) > $this->bufferEventsThreshold) {
 $this->flushEvents();
 }
 } else {
 return $this->_query($params);
 }
 }

 function finalizeEventLogging() {
 global $SESSION_TOKEN, $FEATURE, $DISABLE_DIRT;
 if ($DISABLE_DIRT) {
 return;
 }

 if ($FEATURE["log_dirt_events"] && $this->eventTriggered) {
 $params = array();
 $params["action"] = "trigger";
 $params["sid"] = $SESSION_TOKEN;
 $params["events"] = EVENT_LOGGING_END;

 $rs = $this->_query($params);
 } else {
 $rs = "end logging event not triggered";
 }
 return $rs;
 }

 function startPublish($force = false) {
 
 $params = array();
 $params["action"] = "publish";
 $params["start"] = "TRUE";
 $params["force"] = $force ? "TRUE" : "FALSE";

 $rs = $this->_query($params);

 return $rs;
 }

 function stopPublish() {
 $params = array();
 $params["action"] = "publish";
 $params["stop"] = "TRUE";

 $rs = $this->_query($params);

 return $rs;
 }

 function checkLicenseKey() {
 global $JAVAPARSER_RETURN;

 $rs = $this->_query(array( 'action' => 'licenseCheck', 'noMessages' => true, ));
 $params = $JAVAPARSER_RETURN['params'];
 
 return $params['validLicense'][0] == 'true';
 }

 function startBundleExport( $buildId, $dryrun = false ) {
 global $JAVAPARSER_RETURN, $TIME, $INSTALLATION_NAME, $USER_ID, $FEATURE;

 $rs = $this->_query(array( 'action' => 'queue',
 'cmd' => 'add',
 'type' => $FEATURE['export2'] ? 'export2' : 'export',
 'idparam' => $buildId,
 'additionalparams' => ($dryrun ? "dryrun = true\n" : "")."timestamp=".$TIME."\nsourcehost=".get_sourcehost()."\nuserid=".$USER_ID,
 ));
 return true;
 }

 function startBundleImport( $buildId, $dryrun, $importfolder_id, $conflictBehavior, $groupId ) {
 global $JAVAPARSER_RETURN, $USER_ID, $TIME, $INSTALLATION_NAME, $FEATURE;

 $sourcehost = $INSTALLATION_NAME;
 $rs = $this->_query(array( 'action' => 'queue',
 'cmd' => 'add',
 'type' => $FEATURE['import2'] ? 'import2' : 'import',
 'idparam' => $buildId,
 'additionalparams' => ($dryrun ? 'dryrun = true' : '' ). "\nfolder=".$importfolder_id . "\nconflictBehavior=".$conflictBehavior."\nuserid=".$USER_ID."\ntimestamp=".$TIME."\nglobalPrefix=".get_globalprefix()."\nsourcehost=".$sourcehost."\ngroupid=".$groupId,
 ));
 return true;
 }

 function statusBundle( $buildId ) {
 global $JAVAPARSER_RETURN, $FEATURE;

 $rs = $this->_query(array( 'action' => 'queue', 
 'cmd' => 'status',
 'type' => $FEATURE['export2'] ? 'export2' : 'export', 
 'idparam' => $buildId,
 'noMessages' => true, ));
 $params = $JAVAPARSER_RETURN['params'];

 return array( 'status' => $params['status'][0],
 'queuePosition' => $params['queuePosition'][0],
 'progressPercent' => $params['progressPercent'][0] );
 }

 function cancelBundle( $type, $idparam ) {
 global $JAVAPARSER_RETURN;

 $rs = $this->_query(array( 'action' => 'queue',
 'cmd' => 'cancel',
 'type' => $type,
 'idparam' => $idparam,
 'noMessages' => true ));
 $params = $JAVAPARSER_RETURN['params'];

 return;
 }

 function getQueueStatus( $type, $idparam ) {
 global $JAVAPARSER_RETURN;

 $rs = $this->_query(array( 'action' => 'queue', 
 'cmd' => 'status',
 'type' => $type,
 'idparam' => $idparam,
 'noMessages' => true, ));
 $params = $JAVAPARSER_RETURN['params'];

 return array( 'status' => $params['status'][0],
 'queuePosition' => $params['queuePosition'][0],
 'progressPercent' => $params['progressPercent'][0] );
 }

 








 function startNodeCopy($node_list, $num = 1, $copy_pages = false, $copy_templates = false, $copy_files = false, $copy_workflows = false) {
 global $JAVAPARSER_RETURN, $USER_ID, $LANGUAGE;
 foreach ($node_list as $node) {
 $rs = $this->_query(array(
 'action' => 'queue',
 'cmd' => 'add',
 'type' => 'nodecopy',
 'idparam' => $node,
 'additionalparams' => "num=".$num.
 "\ncopyPages=".($copy_pages ? 'true' : 'false').
 "\ncopyTemplates=".($copy_templates ? 'true' : 'false').
 "\ncopyFiles=".($copy_files ? 'true' : 'false').
 "\ncopyWorkflows=".($copy_workflows ? 'true' : 'false').
 "\nuserid=".$USER_ID.
 "\nlanguage=".$LANGUAGE
 ));
 }

 return true;
 }

 



 function resetPublisher() {
 $params = array();
 $params["action"] = "publish";
 $params["resetPublisher"] = "TRUE";

 $rs = $this->_query($params);

 return $rs;
 }

 function getPublishInfo($noMessages = false) {

 $params = array();
 $params["action"] = "publish";
 $params["start"] = "FALSE";
 if($noMessages) {
 $params["noMessages"] = "TRUE";
 }

 $rs = $this->_query($params);

 return $rs;
 }

 function checkContentrepository($id) {
 global $JAVAPARSER_RETURN;

 $params = array();
 $params["action"] = "contentrepository";
 $params["cmd"] = "check";
 $params["crid"] = $id;

 $this->_query($params);
 }

 function repairContentrepository($id) {
 global $JAVAPARSER_RETURN;

 $params = array();
 $params["action"] = "contentrepository";
 $params["cmd"] = "repair";
 $params["crid"] = $id;

 $this->_query($params);
 }

 function checkContentrepositoryData($cr_id) {
 global $JAVAPARSER_RETURN;

 $params = array();
 $params["action"] = "contentrepository";
 $params["cmd"] = "datacheck";
 $params["crid"] = $cr_id;

 $this->_query($params);
 }

 function cleanContentrepositoryData($cr_id) {
 global $JAVAPARSER_RETURN;

 $params = array();
 $params["action"] = "contentrepository";
 $params["cmd"] = "dataclean";
 $params["crid"] = $cr_id;

 $this->_query($params);
 }


 function clearErrors() {
 $this->errors = array();
 }
 
 function getErrors() {
 return $this->errors;
 }

 function hasErrors() {
 return count($this->errors) > 0;
 }
 
 
 function _query($params) {
 global $JAVAPARSER_RETURN, $FEATURE;

 $JAVAPARSER_RETURN = Array();
 $t1 = microtime();
 
 $rs = $this->connect->query($this->portlet, $params, true);
 
 $msgs = $this->connect->getMessages();
 $JAVAPARSER_RETURN["params"] = $this->connect->getResultParams();

 if($this->connect->fetcher->getReturnCode() == '') {
 halt(7,'Unable to connect to JavaParser.');
 }
 if($this->connect->fetcher->getReturnCode() == '500') {
 halt(120, 'JavaParser returned HTTP code 500. Please check the tomcat logs /Node/tomcat/logs/gentics.log for errors.');
 }
 if($this->connect->fetcher->getReturnCode() == '503') {
 if ($FEATURE['jpAdvanced503Handling']) {
 warning(120, 'JavaParser returned HTTP code 503. Please check whether the internal tomcat is running and accessible.');
 return JavaParserConnectError::render();
 }
 halt(120,'JavaParser returned HTTP code 503. Please check whether the internal tomcat is running and accessible.');
 }

 if($params['noMessages']) return $rs;

 $t2 = microtime();

 if ($params["showErrors"] != "FALSE") {
 
 node_class("debugstreaminfo");
 node_class("infostreaminfo");
 node_class('alertstreaminfo');
 $alert =& new AlertStreamInfo();
 $info =& new InfoStreamInfo();
 $debug =& new DebugStreamInfo();
 
 $debug->addMessage('PortalConnect', null, i18n('Request done in {0}', 0, calctime($t1, $t2, 5)));
 
 $JAVAPARSER_RETURN["messages"] = $msgs;
 foreach ($msgs as $msg) {
 $level = $msg["level"];
 
 unset($stream);
 if ($level == "DEBUG") {
 $stream =& $debug;
 } else if ($level == "FATAL" || $level == "ERROR") {
 $stream =& $alert;
 } else {
 $stream =& $info;
 }

 $detail = "Level: $level\nType: ".$msg["category"]."\n\n".$msg["code"];
 $stream->addMessage('PortalConnect', null, $msg["code"], $detail);
 }

 }
 if( $JAVAPARSER_RETURN["params"]['fatalerror'] && $JAVAPARSER_RETURN["params"]['fatalerror'][0] ) {
 halt(7, 'JavaParser returned fatal error: ' . $JAVAPARSER_RETURN["params"]['fatalerror'][0]);
 }

 return $rs;
 }
 
 


 function _loadConnection($force = false) {
 
 global $PORTAL_CONNECT, $FEATURE;
 
 if (is_object($this->connect) && !$force) {
 return;
 }
 
 unset($this->connect);

 $this->connect =& PortalConnectFactory::getConnection($this->connectName);
 if (!$this->connect) {
 if ($FEATURE["force_javaparser_post"]) {
 $method = "POST";
 } else {
 $method = "";
 }
 if ($FEATURE["use_php_streaming_api"]) {
 $fetcher = new FetchStream($method);
 } else {
 $fetcher = new FetchCurl($method);
 }
 $cookie = $PORTAL_CONNECT["cookie"] ? $PORTAL_CONNECT["cookie"] : "JSESSIONID";
 $this->connect =& PortalConnectFactory::createConnection($this->connectName, $PORTAL_CONNECT["url"], $fetcher, $cookie, true);
 }
 }

 function getEditMode($editMode) {
 switch($editMode) {
 case CN_EM_EDIT:
 return "edit";
 case CN_EM_LIVE:
 return "live";
 case CN_EM_PREVIEW:
 return "preview";
 case CN_EM_REALEDIT:
 return "realedit";
 case CN_EM_REALPREVIEW:
 return "realpreview";
 case CN_EM_PUBLISH:
 default:
 return "publish";
 }
 }

 






 function bufferClearCaches($buffer, $threshold = null) {
 if ($threshold) {
 $this->bufferClearCachesThreshold = $threshold;
 }
 $this->doBufferClearCaches = $buffer;
 if (!$buffer) {
 $this->flushClearCaches();
 }
 }

 


 function flushClearCaches() {
 
 if (count($this->bufferedClearCaches) > 0) {
 $params = array();
 $params["action"] = "clearcache";
 $params["objects"] = implode("|", $this->bufferedClearCaches);

 $rs = $this->_query($params);

 $this->bufferedClearCaches = array();

 return $rs;
 } else {
 return null;
 }
 }

 






 function bufferEvents($buffer, $threshold = null) {
 if ($threshold) {
 $this->bufferEventsThreshold = $threshold;
 }
 $this->doBufferEvents = $buffer;
 if (!$buffer) {
 $this->flushEvents();
 }
 }

 


 function flushEvents() {
 global $SESSION_TOKEN;
 
 if (count($this->bufferedEvents) > 0) {
 $params = array();
 $params["action"] = "trigger";
 $params["sid"] = $SESSION_TOKEN;
 $first = true;
 foreach( $this->bufferedEvents as $bufparams ) {
 $params["me"][] = $this->_internalBuildMulti($bufparams);
 }

 
 
 $rs = $this->_query($params);
 

 $this->bufferedEvents = array();

 return $rs;
 } else {
 return null;
 }
 }

 






 function localizeObject($objType, $objId, $nodeId, $wait = false) {
 global $SID, $LANGUAGE, $USER_ID, $PHPSHELL;
 $params = array();
 $params["action"] = "localizeObject";
 $params["objType"] = $objType;

 if (is_array($objId)) {
 $params["objId"] = implode(",", $objId);
 } else {
 $params["objId"] = $objId;
 }
 $params["cnSessionId"] = $SID;
 
 if ($PHPSHELL) {
 $params["cnUserId"] = $USER_ID;
 }
 $params["nodeId"] = $nodeId;
 $params["language"] = $LANGUAGE;

 if ($wait) {
 
 $params["foregroundTime"] = 600;
 }

 $rs = $this->_query($params);
 
 return $rs;
 }

 




 function refreshPerms($objType, $objId) {
 $params = array();
 $params["action"] = "refreshPerms";
 $params["objType"] = $objType;
 $params["objId"] = $objId;
 $rs = $this->_query($params);
 return $rs;
 }

 



 function refreshGroupPerms($groupId) {
 $params = array();
 $params["action"] = "refreshPerms";
 $params["groupId"] = $groupId;
 $rs = $this->_query($params);
 return $rs;
 }

 



 function refreshRolePerms($roleId) {
 $params = array();
 $params["action"] = "refreshPerms";
 $params["roleId"] = $roleId;
 $rs = $this->_query($params);
 return $rs;
 }

 


 function refreshAllPerms() {
 $params = array();
 $params["action"] = "refreshAllPerms";
 $rs = $this->_query($params);
 return $rs;
 }

 



 function removeGroupPerms($groupId) {
 $params = array();
 $params["action"] = "removePerms";
 $params["groupId"] = $groupId;
 $rs = $this->_query($params);
 return $rs;
 }

 



 function removeRolePerms($roleId) {
 $params = array();
 $params["action"] = "removePerms";
 $params["roleId"] = $roleId;
 $rs = $this->_query($params);
 return $rs;
 }

 



 function checkPerms($fullCheck = false) {
 $params = array();
 $params["action"] = "checkPerms";
 $params["full"] = $fullCheck;
 $rs = $this->_query($params);
 return $rs;
 }

 function _internalBuildMulti($params) {
 $result = "";
 $first = true;
 while(list($key, $value) = each($params)) {
 unset($values);
 if (is_array($value)) {
 $values = $value;
 } else {
 $values[] = $value;
 }
 foreach($values as $val) {
 if ($first) {
 $first = false;
 } else {
 $result .= "&";
 }
 $result .= $key."=".$val;
 }
 }
 return $result;
 }

 



 function startPurgeVersions($timestamp) {
 $params = array();
 $params["action"] = "purgeVersions";
 $params["cmd"] = "start";
 $params["timestamp"] = $timestamp;

 $rs = $this->_query($params);

 return $rs;
 }

 


 function stopPurgeVersions() {
 $params = array();
 $params["action"] = "purgeVersions";
 $params["cmd"] = "stop";

 $rs = $this->_query($params);

 return $rs;
 }

 



 function getPurgeVersionsInfo() {
 $params = array();
 $params["action"] = "purgeVersions";
 $params["cmd"] = "status";

 $rs = $this->_query($params);

 return $rs;
 }

 


 function ping() {
 return $this->_query(array());
 }
}




class JavaParserConnectError {
 
 function render() {
 global $STAG;
 return "
<link rel=\"stylesheet\" href=\"" . $STAG . "&do=20&url=lib/css/main.css\" type=\"text/css\">
<div id=\"hintbox\" style=\"display: block; top: 50px; left: 200px; z-index: 100;\">
	<h3>" . i18n("jpconnerr_title") . "</h3>
	<p>" . i18n("jpconnerr_desc") . "</p>
	<div style=\"text-align: center; margin-top: 20px;\">
		<img src=\"?do=11&module=system&img=loading.gif\" border=\"0\" alt=\"loading\"><br />
		<p>" . i18n("jpconnerr_tmsg") . "</p>
	</div>
</div>

<!-- the error smiley which may return from the dead-->
<img src=\"?do=11&module=content&img=jperr-smiley-dead.gif\" style=\"position: absolute; top: 190px; left: 150px; z-index: 0;\" alt=\"fubar\" id=\"errsmiley\">

<script language=\"javascript\">
var timer = 30;
function countdown() {
	timer--;
	document.getElementById('rtimer').innerHTML = timer;
	if (timer >= 0) {
		setTimeout(countdown, 1000);
	} else {
		document.getElementById('hintbox').style.display = 'none';
		document.getElementById('errsmiley').src = '?do=11&module=content&img=jperr-smiley-alive.gif';
	}
}

setTimeout('window.location.reload();', 29000);
countdown();
</script>
"; 
 }
}



?>
