<?
global $FEATURE;
class DBFileConsistencyObject extends ConsistencyObject {

 var $m_info = "";
 var $m_count = 0;
 var $m_ids = array();

 function getName() { return $this->getKeyname(); }

 function getDescription() { return $this->m_info; }

 function check() {
 global $FILEPATH;
 
 $this->m_info = "";
 $this->m_count = "";
 $this->m_ids = array();
 
 $sql = "SELECT id FROM contentfile";
 $rs = query($sql);
 if ($rs["arr"]) {
 while (list($key,$val) = each($rs["arr"])) {
 $id = $val["id"];
 if (!file_exists($FILEPATH."/content/dbfiles/".$id.".bin")) {
 $this->m_count++;
 $this->m_ids[] = $id;
 $this->m_info .= $id.", ";
 }
 }
 }
 
 return $this->m_count;
 }

 function getInfo() { return "SELECT id FROM contentfile"; }

 function getCheckResult() { return $this->m_count; }

 function canCleanup() { return true; }

 function cleanup() {
 $this->check();
 foreach( $this->m_ids as $id ) {
 $sql = "DELETE FROM contentfile WHERE id = '".sqlf_escaped($id)."'";
 query( $sql );
 }
 }

 function getCommands() {
 return array(
 array( 'cmd' => 'touch',
 'label' => 'y',
 'title' => 'Touch Files',
 )
 );
 }

 function execute($cmd) {
 global $FILEPATH;
 $this->check();
 if( $cmd == 'touch' ) {
 $r = '';
 foreach( $this->m_ids as $id ) {
 $filename = "$FILEPATH/content/dbfiles/$id.bin";
 $r .= "Touching $filename<br>";
 touch($filename);
 }
 return $r;
 }
 }

}

class MappedglobalidConsistencyObject extends SQLConsistencyObject {

 function MappedglobalidConsistencyObject($keyname) {
 parent :: SQLConsistencyObject($keyname, "way too complex to display here... multiple dynamic statements with join over referencing tables for each mappedglobalid entry");

 }

 function getCrossTableSQL() {
 $crossTableSQL = array ();
 $crossTableSQL['template_folder'] = "select m.id from mappedglobalid m left join template_folder t on (t.template_id = m.localid  and m.localid2 = t.folder_id ) where  m.localid != 0 and m.tablename = 'template_folder' and t.template_id IS NULL and t.folder_id IS NULL";
 $crossTableSQL['objprop_node'] = "select m.id from mappedglobalid m left join objprop_node t on (t.objprop_id = m.localid  and m.localid2 = t.node_id ) where  m.localid != 0 and m.tablename = 'objprop_node' and t.objprop_id IS NULL and t.node_id IS NULL";
 $crossTableSQL['node_contentgroup'] = "select m.id from mappedglobalid m left join node_contentgroup t on (t.node_id = m.localid  and m.localid2 = t.contentgroup_id ) where  m.localid != 0 and m.tablename = 'node_contentgroup' and t.node_id IS NULL and t.contentgroup_id IS NULL";
 $crossTableSQL['construct_node'] = "select m.id from mappedglobalid m left join construct_node t on (t.node_id = m.localid  and m.localid2 = t.construct_id ) where  m.localid != 0 and m.tablename = 'construct_node' and t.node_id IS NULL and t.construct_id IS NULL";
 $crossTableSQL['perm'] = "select m.id from mappedglobalid m left join perm t on (t.usergroup_id = m.localid  and m.localid2 = t.o_id ) where  m.localid != 0 and m.tablename = 'perm' and t.o_id IS NULL and t.usergroup_id IS NULL";
 return $crossTableSQL;
 }

 


 function getTableNames() {
 $tablenamesSql = "select tablename from mappedglobalid group by tablename";
 $rs = query($tablenamesSql);
 return $rs['arr'];
 }

 


 function getTableSQL($tableName) {
 return "select m.id from mappedglobalid m left join $tableName t on t.id = m.localid where m.localid != 0 and m.tablename = '$tableName' and t.id IS NULL";
 }

 function canCleanup() {
 return true;
 }

 function check() {

 $ids = $this->getFailedMappedGlobalID();
 $mCount = count($ids);
 $this->m_count = $mCount;
 return $mCount;
 }

 


 function getFailedMappedGlobalID() {
 $tableNames = $this->getTableNames();
 $crossTableSQL = $this->getCrossTableSQL();
 $ids = array ();
 foreach ($tableNames as $key => $value) {
 $tableName = $value[0];
 
 if (isset ($crossTableSQL[$tableName])) {
 continue;
 }
 $rs = query($this->getTableSQL($tableName));
 foreach ($rs['arr'] as $key => $value) {
 array_push($ids, $value['id']);
 }
 }

 foreach ($crossTableSQL as $key => $value) {
 $rs = query($value);
 foreach ($rs['arr'] as $key => $value) {
 array_push($ids, $value['id']);
 }
 }

 return $ids;

 }

 function cleanup() {

 $ids = $this->getFailedMappedGlobalID();
 $sql = "update mappedglobalid set localid = 0 where id in ( " . implode(",", $ids) . ") and tablename NOT in ('template_folder','objprop_node','node_contentgroup','construct_node','perm')";
 query($sql);
 
 $sql = "update mappedglobalid set localid = 0, localid2 = 0 where id in ( " . implode(",", $ids) . ") and tablename in ('template_folder','objprop_node','node_contentgroup','construct_node','perm')";
 query($sql);
 
 }

}

class ContentsetConsistencyObject extends SQLConsistencyObject {

 function ContentsetConsistencyObject($keyname) {
 parent::SQLConsistencyObject($keyname, 
 "SELECT id FROM page WHERE contentgroup_id > 0 AND contentset_id = 0");
 }

 function canCleanup() { return true; }

 function cleanup() {
 $sql = "UPDATE page SET contentgroup_id = 0 WHERE contentset_id = 0";
 query($sql);
 }
}

class ContentsetConsistencyObject2 extends SQLConsistencyObject {

 function ContentsetConsistencyObject2($keyname) {
 parent::SQLConsistencyObject($keyname,
 "select page.id from page left join contentset on page.contentset_id = contentset.id where contentset.id is null and contentset_id != 0",
 "Check whether all necessary contentset records exist (necessary for node copy to work properly!)");
 }

 function canCleanup() { return true; }

 function cleanup() {
 $sql = "INSERT INTO contentset SELECT contentset_id, 0 FROM page LEFT JOIN contentset on page.contentset_id = contentset.id WHERE contentset.id IS NULL AND contentset_id != 0 group by contentset_id";
 query($sql);
 }
}

class OverviewConsistencyObject extends SQLConsistencyObject {

 var $type = null;

 function OverviewConsistencyObject($type) {
 $type = sqlf_table($type);
 parent::SQLConsistencyObject('Overview Values ' . $type,
 "select $type.id from part inner join $type on $type.construct_id = part.construct_id left join value on value.${type}_id = $type.id and value.part_id = part.id where type_id = 13 and value.id is null",
 "Check if all overview parts have values.");
 $this->type = $type;
 }
 function canCleanup() { return true; }


 function cleanup() {
 echo "cleaning up ...<br>";
 $type = sqlf_table($this->type);
 $sql = "select part.id as part_id, $type.id as tag_id from part inner join $type on $type.construct_id = part.construct_id left join value on value.${type}_id = $type.id and value.part_id = part.id where type_id = 13 and value.id is null";
 $rs = query( $sql );
 
 foreach( $rs['arr'] as $row ) {
 $sql = "INSERT INTO value (part_id, ${type}_id, value_text) VALUES (".sqlf_tl_num($row['part_id']).",".sqlf_tl_num($row['tag_id']).",'')";
 echo "executing: $sql<br>";
 query($sql);
 }
 }
}

class MissingValueConsistencyObject extends SQLConsistencyObject {

 var $type = null;
 
 function MissingValueConsistencyObject($type) {
 $type = sqlf_table($type);
 parent::SQLConsistencyObject("Missing $type values for editable parts",
 "select $type.id as tag_id, part.id as part_id from part inner join $type on $type.construct_id = part.construct_id left join value on value.${type}_id = $type.id and value.part_id = part.id where part.editable = 1 and value.id is null and $type.enabled = 1 and exists (select v2.id from value as v2 where v2.part_id = part.id and templatetag_id = 0 and contenttag_id = 0 and globaltag_id = 0 and objtag_id = 0)",
 "check editable parts for missing value entries for $type");
 $this->type = $type;
 }

 function canCleanup() { return true; }

 function cleanup() {
 $rs = query( $this->getSQL() );
 echo "cleaning up missing values for " . $this->type . "<br/>";
 foreach( $rs['arr'] as $row ) {
 $sql = "INSERT INTO value (part_id,info,static,".sqlf_table($this->type)."_id, value_text, value_ref) SELECT part_id, info, 0, " . sqlf_tl_num($row['tag_id']) . ", value_text, value_ref FROM value where part_id = " . sqlf_tl_num($row['part_id']) . " and templatetag_id = 0 and contenttag_id = 0 and globaltag_id = 0 and objtag_id = 0 limit 1";
 echo "executing: $sql<br/>";
 $insertrs = query( $sql );
 if ($insertrs['iid'] == 0) {
 echo "<strong>no inserts !</strong><br/>";
 }
 }
 echo "all done. <strong>make sure to clear the java parser cache (you probably want to do a full republish) !</strong><br/>";
 }

}

class PermDuplicateConsistencyObject extends SQLConsistencyObject {
 function PermDuplicateConsistencyObject() {
 parent::SQLConsistencyObject("Duplicate permission entries",
 "SELECT usergroup_id, o_type, o_id, count(*) c FROM perm GROUP BY usergroup_id, o_type, o_id HAVING c > 1");
 }

 function canCleanup() {
 return true;
 }

 function cleanup() {
 $rs = query( $this->getSQL() );
 echo "removing duplicates<br/>";
 foreach ($rs["arr"] as $row) {
 echo "type:".$row["o_type"].", id:".$row["o_id"].", group:".$row["usergroup_id"]."<br/>";
 $sql = "SELECT DISTINCT perm FROM perm WHERE usergroup_id = ".sqlf_tl_num($row["usergroup_id"])." AND o_type = ".sqlf_tl_num($row["o_type"])." AND o_id = ".sqlf_tl_num($row["o_id"]);
 $rs1 = query($sql);
 if ($rs1["num"] == 1) {
 $sql = "DELETE FROM perm WHERE usergroup_id = ".sqlf_tl_num($row["usergroup_id"])." AND o_type = ".sqlf_tl_num($row["o_type"])." AND o_id = ".sqlf_tl_num($row["o_id"]);
 query($sql);
 $sql = "INSERT INTO perm (usergroup_id, o_type, o_id, perm) VALUES (".sqlf_tl_num($row["usergroup_id"]).", ".sqlf_tl_num($row["o_type"]).", ".sqlf_tl_num($row["o_id"]).", '".sqlf_escaped($rs1["arr"][0]["perm"])."')";
 query($sql);
 } else {
 echo "cannot remove duplicates: different perm settings found!<br/>";
 }
 }
 node_include("codeparser");
 $javaParser =& CodeParser::getJavaParser();
 $javaParser->refreshAllPerms();
 }
}

class PermConsistencyObject extends SQLConsistencyObject {
 var $type = null;
 var $table = null;

 function PermConsistencyObject($type, $table) {
 $type = sqlf_tl_num($type);
 $table = sqlf_table($table);
 parent::SQLConsistencyObject("Permission entries for type $type without object",
 "SELECT * FROM perm LEFT JOIN $table on perm.o_id = $table.id WHERE o_type = $type AND $table.id IS NULL");
 $this->type = $type;
 $this->table = $table;
 }

 function canCleanup() {
 return true;
 }

 function cleanup() {
 $sql = "DELETE perm FROM perm LEFT JOIN ".$this->table." on perm.o_id = ".$this->table.".id WHERE o_type = ".$this->type." AND ".$this->table.".id IS NULL";
 echo "executing: $sql<br/>";
 $rs = query($sql);
 echo "done<br/>";
 }
}

ConsistencyFactory::register(new SQLConsistencyObject("value1", 
 "SELECT count(id) AS c FROM value WHERE contenttag_id = 0 AND templatetag_id = 0 AND objtag_id = 0 AND static = 0 
	 GROUP BY value.part_id HAVING count(id) > 1",
 "lost values default"));

ConsistencyFactory::register(new SQLConsistencyObject("value3", 
 "SELECT count(id) AS c FROM value WHERE static = 1 GROUP BY part_id HAVING c > 1",
 "duplicate static parts"));

ConsistencyFactory::register(new SQLConsistencyObject("value_part3", 
 "SELECT count(id) AS c FROM value WHERE contenttag_id = 0 and templatetag_id = 0 AND objtag_id = 0
	 GROUP BY part_id HAVING count(id) > 1",
 "duplicate default values & static parts"));









ConsistencyFactory::register(new MissingValueConsistencyObject('contenttag'));
ConsistencyFactory::register(new MissingValueConsistencyObject('objtag'));
ConsistencyFactory::register(new MissingValueConsistencyObject('templatetag'));

ConsistencyFactory::register(new SQLConsistencyObject("contenttag2", 
 "SELECT contenttag.id FROM contenttag LEFT JOIN content ON contenttag.content_id = content.id WHERE content.id IS NULL",
 "lost contenttag", 
 "contenttag"));

ConsistencyFactory::register(new SQLConsistencyObject("templatetag2", 
 "SELECT templatetag.id FROM templatetag LEFT JOIN template ON templatetag.template_id = template.id WHERE template.id IS NULL",
 "lost templatetag", 
 "templatetag"));

ConsistencyFactory::register(new SQLConsistencyObject("value_part", 
 "SELECT value.id FROM value LEFT JOIN part ON value.part_id = part.id WHERE part.id IS null",
 "all values joined to parts", 
 "value"));

ConsistencyFactory::register(new SQLConsistencyObject("value2", 
 "SELECT id FROM value WHERE (contenttag_id > 0 AND templatetag_id > 0) OR (templatetag_id > 0 AND objtag_id > 0) OR 
	 (contenttag_id > 0 AND objtag_id > 0) OR (contenttag_id > 0 AND templatetag_id > 0 AND objtag_id > 0)",
 "values which have two different tag_ids", 
 "value"));

ConsistencyFactory::register(new SQLConsistencyObject("templatetag", 
 "SELECT COUNT(id) AS c FROM templatetag GROUP BY template_id, name HAVING count(id) > 1",
 "multiple tags with same name in template"));

ConsistencyFactory::register(new SQLConsistencyObject("contenttag", 
 "SELECT COUNT(content_id) AS c FROM contenttag GROUP BY content_id, name HAVING count(content_id) > 1",
 "multiple tags with same name in page"));

ConsistencyFactory::register(new SQLConsistencyObject("objtag", 
 "SELECT COUNT(id) AS c FROM objtag GROUP BY obj_id, name HAVING count(id) > 1",
 "multiple tags with same name in object"));



ConsistencyFactory::register(new SQLConsistencyObject("page_folder", 
 "SELECT page.id FROM page LEFT JOIN folder ON page.folder_id = folder.id WHERE folder.id IS null",
 "pages are in existing folders", 
 "page"));

ConsistencyFactory::register(new SQLConsistencyObject("publish_page_folder",
 "SELECT p.id FROM publish p LEFT JOIN folder f ON p.folder_id = f.id WHERE f.id IS NULL;",
 "pages in publish table are in existing folders",
 "publish"));

ConsistencyFactory::register(new SQLConsistencyObject("contentfile_folder", 
 "SELECT contentfile.id FROM contentfile LEFT JOIN folder ON folder.id = contentfile.folder_id WHERE folder.id IS NULL",
 "all contentfiles in existing folders",
 "contentfile"));

ConsistencyFactory::register(new DBFileConsistencyObject("contentfile_dbfile"));

ConsistencyFactory::register(new SQLConsistencyObject("contentfile_dbfile_invalidfilename",
 "SELECT id, name FROM contentfile WHERE name IN ('.','..') OR name LIKE '%/%'",
 "check for invalid filenames.",
 "contentfile"));

global $SQLAS;
ConsistencyFactory::register(new SQLConsistencyObject("folder", 
 "SELECT folder.id, folder.mother FROM folder LEFT JOIN folder $SQLAS f ON f.id = folder.mother WHERE f.id IS NULL AND folder.mother > 0",
 "all folders have mothers", 
 "folder"));

ConsistencyFactory::register(new SQLConsistencyObject("folder2",
 "SELECT folder.mother FROM folder LEFT JOIN folder $SQLAS folder2 ON folder.mother = folder2.id
	 WHERE folder.mother > 0 AND folder.node_id != folder2.node_id",
 "all folders have node_id of their mother"));

ConsistencyFactory::register(new SQLConsistencyObject("folder_pub_dir1",
 "SELECT folder.id FROM folder WHERE pub_dir NOT LIKE '/%'",
 "folders must have a beginning /"));

ConsistencyFactory::register(new SQLConsistencyObject("folder_pub_dir2", 
 "SELECT folder.id FROM folder WHERE pub_dir NOT LIKE '%/'",
 "folder must have a trailing /"));

ConsistencyFactory::register(new SQLConsistencyObject("construct_node1",
 "SELECT construct_id, node_id FROM construct_node LEFT JOIN construct ON construct_node.construct_id = construct.id 
	 WHERE construct.id IS NULL",
 "check Construct_node table",
 "construct_node", "construct_id", "node_id"));

ConsistencyFactory::register(new SQLConsistencyObject("construct_node2",
 "SELECT construct_id, node_id FROM construct_node LEFT JOIN node ON construct_node.node_id = node.id WHERE node.id IS NULL",
 "check Construct_node table",
 "construct_node", "construct_id", "node_id"));

ConsistencyFactory::register(new SQLConsistencyObject("page", 
 "SELECT id FROM page WHERE content_id = 0",
 "Check if all pages have contents"));
 
ConsistencyFactory::register(new SQLConsistencyObject("page_content1",
 "SELECT page.id FROM page LEFT JOIN content ON page.content_id = content.id WHERE content.id IS NULL",
 "Check if pages have non-existing content",
 "page"));

ConsistencyFactory::register(new SQLConsistencyObject("page_content",
 "SELECT content.id FROM content LEFT JOIN page ON content.id = page.content_id WHERE page.id IS NULL",
 "Check if contents are connected to existing pages",
 "content"));

ConsistencyFactory::register(new SQLConsistencyObject("templatetag_construct",
 "SELECT templatetag.id FROM templatetag LEFT JOIN construct ON templatetag.construct_id = construct.id WHERE construct.id IS NULL",
 "Check if templatetags use existing constructs",
 "templatetag"));

ConsistencyFactory::register(new SQLConsistencyObject("contenttag_construct",
 "SELECT contenttag.id FROM contenttag LEFT JOIN construct ON contenttag.construct_id = construct.id WHERE construct.id IS NULL",
 "Check if contenttag use existing constructs",
 "contenttag"));

ConsistencyFactory::register(new SQLConsistencyObject("objtag_construct",
 "SELECT objtag.id FROM objtag LEFT JOIN construct ON objtag.construct_id = construct.id WHERE construct.id IS NULL",
 "objtag"));

ConsistencyFactory::register(new SQLConsistencyObject("node_folder1",
 "SELECT node.id FROM node LEFT JOIN folder ON folder.id = node.folder_id WHERE folder.id IS NULL",
 "all nodes have folders"));

ConsistencyFactory::register(new SQLConsistencyObject("node_folder2",
 "SELECT node.id, folder.id, folder.mother FROM node, folder WHERE node.folder_id = folder.id AND folder.mother != 0",
 "all folders of nodes have mother = 0"));

ConsistencyFactory::register(new SQLConsistencyObject("node_folder3",
 "SELECT folder.id FROM folder LEFT JOIN node ON folder.node_id = node.id WHERE node.id IS NULL",
 "all folders have nodes"));

ConsistencyFactory::register(new SQLConsistencyObject("publish",
 "SELECT publish.id FROM publish LEFT JOIN page ON publish.page_id = page.id WHERE page.id IS NULL",
 "",
 "publish"));

ConsistencyFactory::register(new SQLConsistencyObject("contentgroup",
 "SELECT count(id) AS c FROM page WHERE contentset_id > 0 AND contentgroup_id > 0 GROUP BY contentset_id, contentgroup_id HAVING c > 1"));

ConsistencyFactory::register(new SQLConsistencyObject("contentset",
 "SELECT count(id) AS c FROM page WHERE contentset_id = 0 OR contentset_id IS NULL"));
 

ConsistencyFactory::register(new SQLConsistencyObject("template_folder",
 "SELECT template_folder.template_id FROM template_folder LEFT JOIN template ON template_folder.template_id = template.id WHERE template.id IS NULL",
 "folders are not linked to non-existent templates",
 "template_folder", "template_id"));

ConsistencyFactory::register(new ContentsetConsistencyObject("contentset2") );

ConsistencyFactory::register(new ContentsetConsistencyObject2("contentset3") );

ConsistencyFactory :: register(new MappedglobalidConsistencyObject("mappedglobalid"));


ConsistencyFactory::register( new SQLConsistencyObject( "contenttag3", 
 "SELECT contenttag.id FROM page, templatetag, contenttag WHERE page.content_id = contenttag.content_id AND templatetag.template_id = page.template_id AND contenttag.name = templatetag.name AND contenttag.construct_id != templatetag.construct_id" ) );

ConsistencyFactory::register( new OverviewConsistencyObject( 'templatetag' ) );
ConsistencyFactory::register( new OverviewConsistencyObject( 'contenttag' ) );

 ConsistencyFactory::register(new DependencyConsistencyObject( "Page-Dependecies", T_PAGE, "page" ) );
 ConsistencyFactory::register(new DependencyConsistencyObject( "Folder-Dependecies", T_FOLDER, "folder" ) );
 ConsistencyFactory::register(new DependencyConsistencyObject( "File-Dependecies", CT_FILE, "contentfile" ) );
 ConsistencyFactory::register(new DependencyConsistencyObject( "Image-Dependecies", T_IMAGE, "contentfile" ) );

ConsistencyFactory::register(new PermDuplicateConsistencyObject());

ConsistencyFactory::register(new PermConsistencyObject(40, "objtag"));
ConsistencyFactory::register(new PermConsistencyObject(10001, "folder"));
ConsistencyFactory::register(new PermConsistencyObject(10002, "folder"));
ConsistencyFactory::register(new PermConsistencyObject(10033, "folder"));
ConsistencyFactory::register(new PermConsistencyObject(10027, "datasource"));
ConsistencyFactory::register(new PermConsistencyObject(10208, "contentrepository"));
ConsistencyFactory::register(new PermConsistencyObject(137, "bundle"));
ConsistencyFactory::register(new PermConsistencyObject(138, "bundle"));
ConsistencyFactory::register(new PermConsistencyObject(38, "tasktemplate"));
ConsistencyFactory::register(new PermConsistencyObject(37, "task"));
ConsistencyFactory::register(new PermConsistencyObject(39, "job"));

ConsistencyFactory::register(new SQLConsistencyObject(
 "Duplicate objtag rows", 
 "SELECT ot_this.id FROM objtag ot_this
		LEFT JOIN objtag ot_other ON ot_other.obj_type=ot_this.obj_type AND ot_other.obj_id=ot_this.obj_id AND ot_other.id > ot_this.id AND ot_other.name=ot_this.name
		WHERE ot_other.obj_id IS NOT NULL",
 "Number of duplicate objtag rows, this can lead to SGB's (RT:#52297)"
));

ConsistencyFactory::register(new SQLConsistencyObject(
 "value rows with invalid objtag",
 "SELECT v.id FROM value v LEFT JOIN objtag ot ON v.objtag_id=ot.id WHERE v.objtag_id > 0 AND ot.id IS NULL;",
 "Number of values with invalid objtag (RT:#52297)"
));
