<?

global $CN_MAP;
node_class("cncontentmap");
$CN_MAP = new CNContentmap();

function tagmap_start_transaction() {
 global $CN_MAP;
 $CN_MAP->startTransaction();
}

function tagmap_commit() {
 global $CN_MAP;
 $CN_MAP->commit();
}

function log_publish($fp, $outp) {
 fwrite($fp,$outp);
 fflush($fp);
}

function get_quickname_of_mapname($mapname) {
 return "quick_".str_replace(".","_",$mapname);
}

function update_tagmap() {
 global $CN_MAP, $LOG_FP;
 $sql = "SELECT mapname, attributetype, optimized, multivalue, object, objtype, foreignlinkattribute, foreignlinkattributerule FROM tagmap";
 $rs = query($sql);

 $cn_maps = $CN_MAP->getConfigurations();
 foreach ($cn_maps as $cn_map_key=>$map) {
 $outp = "Updating tagmap $map...\n";
 if ( $LOG_FP ) log_publish($LOG_FP, $outp);
 
 $CN_MAP_DB = $CN_MAP->getCnMapHandleByKey($cn_map_key);
 if ($CN_MAP_DB === false) continue;
 
 $drops = array();
 
 query( "DELETE FROM contentattributetype", $CN_MAP_DB );
 foreach($rs["arr"] as $row) {
 $desc = mydb_desc_table("contentmap",$CN_MAP_DB,true);
 $quickname = get_quickname_of_mapname($row["mapname"]);
 if (!$row["optimized"]){
 if ($desc[$quickname]) $drops[$quickname] = true;
 $quickname = "";
 }
 if (!$desc[$quickname] && $quickname) {
 $createindex = TRUE;
 switch ($row["attributetype"]) {
 case ATTR_TYPE_TEXT:
 $coltype = "varchar(255)";
 $type = "text";
 $coldef = "";
 break;
 case ATTR_TYPE_OBJ:
 $coltype = "varchar(32)";
 $type = "text";
 $coldef = "";
 break;
 case ATTR_TYPE_INTEGER:
 $coltype = "int";
 $type = "int";
 $coldef = 0;
 break;
 case ATTR_TYPE_CLOB:
 $coltype = "longtext";
 $type = "clob";
 $coldef = "";
 $createindex = FALSE;
 break;
 case ATTR_TYPE_BLOB:
 $coltype = "blob";
 $type = "blob";
 $coldef = "";
 $createindex = FALSE;
 break;
 default:
 unset($type);
 }

 if ($type) {
 $typearr["type"] = $coltype;
 $typearr["default"] = $coldef;
 $typearr["null"] = true;
 mydb_add_column("contentmap",$quickname,$typearr,$CN_MAP_DB);
 $md = substr(md5($quickname),0,16);
 if($createindex) {
 mydb_add_index("contentmap",Array($quickname),"idxq".$md,"key",$CN_MAP_DB);
 }

 $outp = "adding column: name($quickname)/coltype($coltype)/coldef($coldef)/";
 if($createindex) $outp .= "index(idxq$md)\n";
 else $outp .= "not creating index\n";
 if ( $LOG_FP ) log_publish($LOG_FP, $outp);

 if ($CN_MAP_DB["type"] == "ora") {
 $sql = "UPDATE contentmap m SET ".sqlf_field($quickname)." = (SELECT ".sqlf_field("value_$type")." FROM contentattribute a ".
 "WHERE a.contentid = m.contentid AND a.name = '".sqlf_escaped($row["mapname"])."')";
 query($sql,$CN_MAP_DB);
 } else {
 $sql = "SELECT contentid, ".sqlf_field("value_$type")." v FROM contentattribute WHERE name = '".sqlf_escaped($row["mapname"])."'";
 $rs1 = query($sql,$CN_MAP_DB);
 foreach($rs1["arr"] as $subrow) {
 $sql = "UPDATE contentmap SET ".sqlf_field($quickname)." = '".sqlslashes($subrow["v"],$CN_MAP_DB)."' WHERE contentid = '".sqlf_escaped($subrow["contentid"])."'";
 query($sql,$CN_MAP_DB);
 }
 }
 }
 }
 $sql = "INSERT INTO contentattributetype (name,quickname,attributetype,multivalue,optimized,objecttype, linkedobjecttype, foreignlinkattribute, foreignlinkattributerule) VALUES ('".sqlf_escaped($row["mapname"])."','".sqlf_escaped($quickname)."',".sqlf_tl_num($row["attributetype"]).",".sqlf_tl_num($row["multivalue"]).",".sqlf_tl_num($row["optimized"]).",".sqlf_tl_num($row["object"]).",".sqlf_tl_num($row["objtype"]).",'".sqlf_escaped($row["foreignlinkattribute"])."','".sqlslashes($row["foreignlinkattributerule"])."')";
 query($sql, $CN_MAP_DB);
 }

 foreach($drops as $drop=>$_tmp123) {
 $outp = "dropping column: name($drop)\n";
 if ( $LOG_FP ) log_publish($LOG_FP, $outp);
 mydb_drop_column("contentmap",$drop,$CN_MAP_DB);
 }
 }

 $outp = "Done (update tagmap).\n";
 if ( $LOG_FP ) log_publish($LOG_FP, $outp);
}


function db_query( $db, $sql, $oraSql, $bindVar , $bindtype = 1)
{
 set_time_limit(0);
 if ( $db["type"] == "ora" && $bindVar )
 {
 return query($oraSql, false, 0, $db, 0, $bindVar, $bindtype);
 }
 else
 return query( $sql, $db );
}

function to_contentmap_charset($val, $node_id){
 global $FEATURE, $CN_MAP;
 $charset = $CN_MAP->getCnMapCharset($node_id);
 if ( $charset ) {
 if ( $charset == "ISO-8859-1" || $charset == "ISO-8859-15" )
 $ret = cp1252_to_htmlentities( $val );
 else
 $ret = iconv("CP1252", $charset, $val);
 return $ret;
 } else {
 return $val;
 }
}

function translate_contenttype($v, $row, $isMulti, $node_id)
{
 global $FEATURE;
 
 if ($row["attributetype"] == ATTR_TYPE_INTEGER) {
 $col = "value_int";
 if ( $isMulti )
 {
 $value = array();
 if ( is_array($v ) )
 {
 foreach ( $v as $val )
 {
 $value[] = array( "plain"=>intval($val), "mysql"=>intval($val) );
 }
 }
 }
 else
 $value = array( "plain"=>intval($v), "mysql"=>intval($v) );
 } else if ($row["attributetype"] == ATTR_TYPE_TEXT) {
 $col = "value_text";
 if ( $isMulti )
 {
 $value = array();
 if ( is_array($v ) )
 {
 foreach ( $v as $val )
 {
 $value[] = array( "mysql"=>"'".sqlslashes(to_contentmap_charset($val, $node_id))."'", "plain"=>to_contentmap_charset($val, $node_id) );
 }
 }
 }
 else
 $value = array( "mysql"=>"'".sqlslashes(to_contentmap_charset($v, $node_id))."'", "plain"=>to_contentmap_charset($v, $node_id) );
 } else if ($row["attributetype"] == ATTR_TYPE_OBJ) {
 $col = "value_text";
 if ( $isMulti )
 {
 $value = array();
 if ( is_array($v ) )
 {
 foreach ( $v as $val )
 {
 if ( strlen( $val ) > 0 ) {
 $value[] = array( "mysql"=>"'".$row["objtype"].".$val'", "plain"=>$row["objtype"].".$val" );
 }
 }
 }
 }
 else
 {
 if ( strlen( $v ) > 0 ) {
 $value = array( "mysql"=>"'".$row["objtype"].".$v'", "plain"=>$row["objtype"].".$v" );
 }
 else
 $value = array( "mysql"=>"''", "plain"=>"" );
 }
 } else if ($row["attributetype"] == ATTR_TYPE_BINARY) {
 $col = "value_bin";
 if ( $isMulti )
 {
 $value = array();
 if ( is_array($v ) )
 {
 foreach ( $v as $val )
 {
 $value[] = array( "mysql"=>"'".sqlslashes(to_contentmap_charset($val, $node_id))."'", "plain"=>to_contentmap_charset($val, $node_id) );
 }
 }
 }
 else
 $value = array( "mysql"=>"'".sqlslashes(to_contentmap_charset($v, $node_id))."'", "plain"=>to_contentmap_charset($v, $node_id) );
 } else if ($row["attributetype"] == ATTR_TYPE_CLOB) {
 $col = "value_clob";
 if ( $isMulti )
 {
 $value = array();
 if ( is_array($v ) )
 {
 foreach ( $v as $val )
 {
 $value[] = array( "mysql"=>"'".sqlslashes(to_contentmap_charset($val, $node_id))."'", "plain"=>to_contentmap_charset($val, $node_id) );
 }
 }
 }
 else
 $value = array( "mysql"=>"'".sqlslashes(to_contentmap_charset($v, $node_id))."'", "plain"=>to_contentmap_charset($v, $node_id) );
 } else if ($row["attributetype"] == ATTR_TYPE_BLOB) {
 $col = "value_blob";
 $value = array("mysql"=>"'".sqlslashes($v)."'","plain"=>$v);
 $value["oracle_bindtype"] = OCI_B_BLOB;
 } else if ($row["attributetype"] == ATTR_TYPE_FOREIGNOBJ) {
 
 $col = false;
 $value = "";
 } else halt(7,"update contentmap: invalid tagmap.type(".$row["attributetype"].") found.");
 
 return array( "value"=>$value, "col"=>$col, "multi"=>$isMulti );
}


function update_contentmap($obj_id,$obj_type,$mother_obj_id,$mother_obj_type,$node_id,$tags = Array(),$meta = Array(),$excluded = Array()) {

 global $TIME, $CN_MAP, $LOG_FP, $DEBUG, $FEATURE;
 if ($DEBUG["publish_time"]) {
 $DEBUG["dbtime_fp"] = $LOG_FP;
 $t["update_contentmap_start"] = microtime();
 }
 set_time_limit(0);
 $_id = "$obj_type.$obj_id";

 $meta["contentid"] = $_id;
 $meta["obj_type"] = $obj_type;
 
 $outp = "mapupdate: ".$obj_type."/".$obj_id."\t";
 if ( $LOG_FP ) log_publish($LOG_FP, $outp);
 foreach($excluded as $ex) {
 $sqlpart .= " AND name != '".sqlf_escaped($ex)."'";
 }
 
 $CN_MAP_DB = $CN_MAP->getCnMapHandle($node_id);
 
 $parseXnl = false;
 if ($FEATURE["xnl"]) {
 static $xnlParser;
 if (!isset($xnlParser)) {
 node_class("parserfactory");
 $xnlParser = &ParserFactory::getInstanceOf("xnl");
 $xnlParser->setShowErrors(false);
 $xnlParser->setEvaluate(true);
 }

 $baseObj =& NodeFactory::getInstanceOf($obj_type, $obj_id);
 if (is_object($baseObj)) {
 $xnlParser->setBaseObject($baseObj);
 $xnlParser->setHandleDependencies(false);
 $parseXnl = true;
 }
 }
 
 $sql = "DELETE FROM contentattribute WHERE contentid = '".sqlf_escaped($_id)."'".$sqlpart;
 query($sql,$CN_MAP_DB);
 $sql = "DELETE FROM contentmap WHERE contentid = '".sqlf_escaped($_id)."'";
 query($sql,$CN_MAP_DB);
 $sql = "INSERT INTO contentmap (contentid,obj_id,obj_type,mother_obj_id,mother_obj_type,motherid,updatetimestamp) VALUES ".
 "('".sqlf_escaped($_id)."',".sqlf_tl_num($obj_id).",".sqlf_tl_num($obj_type).",".sqlf_tl_num($mother_obj_id).",".sqlf_tl_num($mother_obj_type).",'".sqlf_escaped("$mother_obj_type.$mother_obj_id")."',".sqlf_tl_num($TIME).")";
 query($sql,$CN_MAP_DB);
 $sql = "SELECT * FROM tagmap WHERE object = ".sqlf_tl_num($obj_type);
 $rs = query($sql,true);
 if ($DEBUG["publish_time"]) $t["update_contentmap_startvalues"] = microtime();
 foreach($rs["arr"] as $row) {
 
 if (is_int(array_search($row["mapname"],$excluded))) continue;

 $isMulti = $row["multivalue"] == "1";
 if (isset($tags[$row["tagname"]]["value"])) {
 $v = $tags[$row["tagname"]]["value"];
 
 if ( !is_array( $v ) )
 $v = code_translate( $v, $tags, "", false, array(), "page", 0, false, $node_id ); 
 if ($parseXnl) $v = $xnlParser->parse($v);
 }
 else if (isset($meta[$row["mapname"]])) $v = $meta[$row["mapname"]];
 else $v = "";
 $res = translate_contenttype($v, $row, $isMulti, $node_id);
 $col = $res["col"];
 $value = $res["value"];
 
 if ($col) {
 if ( $res["multi"] )
 {
 $sortorder=1;
 foreach ( $value as $val )
 {
 $sql = "INSERT INTO contentattribute (contentid,name,".sqlf_field($col).",sortorder) VALUES ".
 "('".sqlf_escaped($_id)."','".sqlf_escaped($row["mapname"])."',".sqlf_value($val["mysql"]).",".sqlf_tl_num($sortorder).")";
 $oraSql = "INSERT INTO contentattribute (contentid,name,".sqlf_field($col).",sortorder) VALUES ".
 "('".sqlf_escaped($_id)."','".sqlf_escaped($row["mapname"])."',:bindvar, ".sqlf_tl_num($sortorder).")";
 db_query($CN_MAP_DB, $sql, $oraSql, $val["plain"], 
 array( "type"=>$val["oracle_bindtype"]?$val["oracle_bindtype"]:1, "field"=>$col ) );
 $sortorder++;
 }
 }
 else
 {
 $sql = "INSERT INTO contentattribute (contentid,name,".sqlf_field($col).") VALUES ".
 "('".sqlf_escaped($_id)."','".sqlf_escaped($row["mapname"])."',".sqlf_value($value["mysql"]).")";
 $oraSql = "INSERT INTO contentattribute (contentid,name,".sqlf_field($col).") VALUES ".
 "('".sqlf_escaped($_id)."','".sqlf_escaped($row["mapname"])."',:bindvar)";
 db_query($CN_MAP_DB, $sql, $oraSql, $value["plain"],
 array( "type"=>$value["oracle_bindtype"]?$value["oracle_bindtype"]:1, "field"=>$col) );

 $quicks = get_quicknames();
 $quickcols = get_quickcols($node_id);
 if ($quicks[$row["mapname"]] && $quickcols[$quicks[$row["mapname"]]]) {
 $sql = "UPDATE contentmap SET ".sqlf_field($quicks[$row["mapname"]])." = ".sqlf_value($value["mysql"])." WHERE contentid = '".sqlf_escaped($_id)."'";
 $oraSql = "UPDATE contentmap SET ".sqlf_field($quicks[$row["mapname"]])." = :bindvar WHERE contentid = '".sqlf_escaped($_id)."'";
 db_query($CN_MAP_DB,$sql,$oraSql,$value["plain"], 
 array( "type"=>$value["oracle_bindtype"]?$value["oracle_bindtype"]:1, "field"=>$col) );
 }
 }
 }
 }
 if ($DEBUG["publish_time"]) {
 $t["update_contentmap_end"] = microtime();
 logdetailtime($t);
 $DEBUG["dbtime_fb"] = false;
 }

}

function get_quicknames() {
 static $CN_MAP_QUICKNAME_CACHE;
 if ($CN_MAP_QUICKNAME_CACHE) return $CN_MAP_QUICKNAME_CACHE;
 $sql = "SELECT mapname FROM tagmap WHERE optimized = 1";
 $rs = query($sql);
 foreach($rs["arr"] as $row) {
 $quicks[$row["mapname"]] = get_quickname_of_mapname($row["mapname"]);
 }
 $CN_MAP_QUICNAME_CACHE = $quicks;
 return $quicks;
}

function get_quickcols($node_id) {
 static $CN_MAP_QUICKCOL_CACHE;
 if ($CN_MAP_QUICKCOL_CACHE[$node_id]) return $CN_MAP_QUICKCOL_CACHE[$node_id];
 global $CN_MAP;
 $CN_MAP_DB = $CN_MAP->getCnMapHandle($node_id);
 $quicks = get_quicknames();
 $desc = mydb_desc_table("contentmap",$CN_MAP_DB,true);
 foreach($quicks as $quick) {
 if ($desc[$quick]) $quickcols[$quick] = true;
 }
 $CN_MAP_QUICKCOL_CACHE[$node_id] = $quickcols;
 return $quickcols;
}
 

function delete_content_object( $o_type, $o_id, $db, $reason = FALSE )
{
 global $LOG_FP;
 $outp = "mapsync.remove: ".$o_type."/".$o_id.($reason?" ($reason)":'')."\n";
 if ($LOG_FP) log_publish($LOG_FP, $outp);
 set_time_limit(0);
 
 $sql = "DELETE FROM contentattribute WHERE contentid='".sqlf_escaped("$o_type.$o_id")."'";
 query( $sql, $db );
 $sql = "DELETE FROM contentmap WHERE obj_type = ".sqlf_tl_num($o_type)." AND obj_id = ".sqlf_tl_num($o_id);
 query( $sql, $db );
}


function publish_page($page_id, $skip_status = false) {

global $TIME, $USER_ID, $PUBWAY, $CONTENTTAG_VISITED, $TEMPLATETAG_VISITED, $T_FOLDER, $T_TEMPLATE, $T_PAGE, $FEATURE, $W_GENERATE, $CN_PORTALTAGS, $LOG_FP, $DEBUG, $REPUBLISH_NODES, $TS_STATUS_RESET, $TS;

$dtime = $DEBUG["time"];

if ($dtime) $_t1 = microtime();

$PUBWAY = "stat";
$CONTENTTAG_VISITED = Array();
$TEMPLATETAG_VISITED = Array();

$timing = array();
$timing["begin"] = microtime();


$page = get_page_source($page_id);
$source = $page["source"];

$page = get_pageinfo($page_id);
$pagename = $page["name"];
$template_id = $page["tid"];
$content_id = $page["cid"];
$folder_id = $page["folder_id"];
$status = $page["status"];
$publisher = $page["publisher"];
$pdate = $page["pdate"];
$edate = $page["edate"];
$filename = sqlslashes($page["filename"]);

if (!$folder_id) return true;

$folder = get_folderinfo($folder_id);
$node_id = $folder["node_id"];
$node = get_nodeinfo($node_id);

$path = sqlslashes(get_folderpath($folder_id));








if ($status != 1) return true;

if ($dtime) $_t2 = microtime();


if ($FEATURE["xnl"]) {

 $baseObj = new CNPageObject($page_id);

 static $xnlParser;
 if (!is_object($xnlParser)) {
 $xnlParser = &ParserFactory::getInstanceOf("xnl");
 $xnlParser->setShowErrors(true);
 $xnlParser->setEvaluate(true);
 }

 $xnlParser->setBaseObject($baseObj);
 $xnlParser->setHandleDependencies(true);
 $xnlParser->clearEventMap();
}

if ($dtime) $_t3 = microtime();

$tags = translate_pagecontent($page_id, false, 0, 0, true);

$timing["objtr"] = microtime();

$source = code_translate($source,$tags,"page",false,Array(),"page",$page_id, false, $node_id);

$timing["codetr"] = microtime();


if ($FEATURE["xnl"]) {
 $source = $xnlParser->parse($source);
}
$timing["xnl"] = microtime();

if ($FEATURE["contentmap"] && $node["publish_contentmap"]) {
 
 $_meta = Array();
 $_meta["content"] = $source;
 update_contentmap($page_id,$T_PAGE,$folder_id,$T_FOLDER,$node_id,$tags,$_meta);
}

$timing["map"] = microtime();


if ($skip_status) {
 
 static $repubFuncs = false;
 if ($repubFuncs === false) {
 $repubFuncs = array();
 $request =& $xnlParser->getRequestor();
 $funcs = $request->getFunctions();
 foreach ($funcs as $func) {
 if ($request->getFuncNeedsRepublish($func)) $repubFuncs[] = $func;
 }
 }

 $skip_status = false;
 foreach ($repubFuncs as $func) {
 
 if (($pos = strrpos($func, ".")) !== false) {
 $funcName = substr($func, $pos + 1);
 $funcTags = $xnlParser->findParserTags("function", $funcName, true);
 if (count($funcTags)) {
 $skip_status = true;
 break;
 }
 }
 $funcTags = $xnlParser->findParserTags("function", $func, true);
 if (count($funcTags)) {
 $skip_status = true;
 break;
 }
 }
}

if ($dtime) $_t4 = microtime();

if (!$skip_status) {

 $source = sqlslashes($source);
 $sql = "UPDATE publish SET active = 0 WHERE page_id = ".sqlf_tl_num($page_id);
 query($sql);
 $sql = "INSERT INTO publish (page_id,node_id,folder_id,path,filename,source,pdate,active) VALUES
	(".sqlf_tl_num($page_id).",".sqlf_tl_num($node_id).",".sqlf_tl_num($folder_id).",'".sqlf_escaped($path)."','".sqlf_escaped($filename)."','".sqlf_escaped($source)."',".sqlf_tl_num($TIME).",1)";
 query($sql);


 $timing["pub"] = microtime();

 unset($source);

 

 
 $do_status = 1;
 if ($TS_STATUS_RESET) {
 global $W_DIRT, $T_PAGECONTENT;
 $sql = "SELECT page.id FROM page,logcmd WHERE logcmd.timestamp > ".sqlf_tl_num($TS_STATUS_RESET)." AND ((page.content_id = logcmd.o_id AND logcmd.o_type = ".sqlf_tl_num($T_PAGECONTENT).") OR (page.id = logcmd.o_id AND logcmd.o_type = ".sqlf_tl_num($T_PAGE).")) AND page.id = ".sqlf_tl_num($page_id)." AND logcmd.cmd_desc_id IN (".sqlf_tl_num(W_MODIFY).", ".sqlf_tl_num($W_DIRT).")";
 $rs = query($sql);
 
 if ($rs["num"]) {
 $do_status = 0;
 }
 }
 
 if ($do_status) { 
 $sql = "UPDATE page SET status = 2 WHERE id = ".sqlf_tl_num($page_id)." AND status = 1";
 query($sql);
 }

 logcmd($W_GENERATE,$T_PAGE,$page_id,0,"publish");
}
$timing["end"] = microtime();

if ( $DEBUG["publish_time"] )
{

 $TS["sum_publish_page_start"] += calctime($_t1,$_t2,12);
 $TS["sum_publish_page_start_invocations"] += 1;
 $TS["sum_publish_page_xnlprep"] += calctime($_t2,$_t3,12);
 $TS["sum_publish_page_trpage"] += calctime($_t3,$timing["objtr"],12);
 $TS["sum_publish_page_codetr"] += calctime($timing["objtr"],$timing["codetr"],12);
 $TS["sum_publish_page_xnl"] += calctime($timing["codetr"],$timing["xnl"],12);
 $TS["sum_publish_page_map"] += calctime($timing["xnl"],$timing["map"],12);
 $TS["sum_publish_page_xnlneedsrepub"] += calctime($timing["map"],$_t4,12);
 $TS["sum_publish_page_end"] += calctime($_t4,$timing["end"],12);

 $prev = 0;
 $outp = "";
 foreach ( $timing as $tname=>$time )
 {
 if ( $prev != 0 )
 {
 $outp .= $tname."(".calctime($prev,$time,2)."),";
 }
 $prev = $time;
 $outp = substr($outp,0,-1)."\n";
 }
}
else
{
 $outp = "(".calctime($timing["begin"],$timing["end"],3).")";
}

if ( $LOG_FP ) {
 log_publish($LOG_FP, $outp);
}

$PUBWAY = "dyn";

return !$skip_status;

}

function get_lastmapupdate($mapKey) {

 global $CN_MAP;
 
 $CN_MAP_DB = $CN_MAP->getCnMapHandleByKey($mapKey);
 $sql = "SELECT intvalue FROM contentstatus WHERE name = 'lastupdate'";
 $rs = query($sql,false, 0, $CN_MAP_DB);
 if ($rs["num"] > 0) return intval($rs["arr"][0]["intvalue"]);
 else return 0;
}

function set_lastmapupdate( $time, $mapKey = "" )
{
 global $CN_MAP;

 if ($mapKey) $maps = array($mapKey=>$mapKey);
 else $maps = $CN_MAP->getConfigurations();
 
 foreach ($maps as $key=>$val) {
 $CN_MAP_DB = $CN_MAP->getCnMapHandleByKey($key);
 $sql = "SELECT intvalue FROM contentstatus WHERE name = 'lastupdate'";
 $rs = query($sql, $CN_MAP_DB);
 if ( $rs["num"] > 0 ) {
 $sql = "UPDATE contentstatus SET intvalue=".sqlf_tl_num($time)." WHERE name = 'lastupdate'";
 query($sql,$CN_MAP_DB);
 } else {
 $sql = "INSERT INTO contentstatus (name,intvalue) VALUES ('lastupdate', ".sqlf_tl_num($time).")";
 query($sql,$CN_MAP_DB);
 }
 }
 
 



 
 $nodeIdsArr = explode(',',getPublishNodeIdSet());
 while (list(,$nodeId)=each($nodeIdsArr)) {
 logcmd(W_PAGEPUB, T_NODE, $nodeId, 0, "published node $nodeId");
 }
}

function publish_events($t_types = array(T_PAGE, CT_FILE, T_FOLDER), $events=false) {
 global $FEATURE, $T_PAGE, $CN_MAP, $LOG_FP;
 
 $maps = $CN_MAP->getConfigurations();
 
 foreach ($maps as $mapKey=>$val) {
 if (!$CN_MAP->doPublishNotificationsByKey($mapKey)) continue;
 
 $lastupdate = get_lastmapupdate($mapKey);
 $logcmds = array();

 if ( $events )
 {
 $events_sql = "AND logcmd.cmd_desc_id IN (".implode(",",sqlf_tl_num_array($events)).") ";
 } else $events_sql = "";
 
 if ( $lastupdate > 0 ) {
 $lastupdate_sql = "AND logcmd.timestamp > ".sqlf_tl_num($lastupdate)." ";
 } else $lastupdate_sql = "";
 
 if ( !$CN_MAP->doPublishNotificationQueueByKey($mapKey) )
 $queue_sql = " GROUP BY id, cmd_desc_id ORDER BY mt ASC ";
 else
 $queue_sql = "";
 
 $sql = "SELECT o_type, o_id, max(timestamp) mt, cmd_desc_id FROM logcmd WHERE ".
 "o_type IN ( " . implode( ",", sqlf_tl_num_array($t_types) ) . ") $lastupdate_sql ".
 $events_sql . $queue_sql;
 $rs = query($sql);

 if ( !$CN_MAP->doPublishNotificationQueueByKey($mapKey) )
 {
 
 
 $logcmds = array();
 foreach ( $rs["arr"] as $key=>$row )
 {
 if ( isset($rs["arr"][$key+1]) )
 if ( $rs["arr"][$key+1]["o_type"] == $row["o_type"] && $rs["arr"][$key+1]["o_id"] == $row["o_id"] )
 continue;

 $logcmds[] = $row;
 }
 
 }
 else
 $logcmds = $rs["arr"];
 

 log_publish($LOG_FP, "\nEvents to publish: ".count($logcmds)."\n");
 
 foreach ( $logcmds as $row )
 {
 $contentid = $row["o_type"] . "." . $row["o_id"];
 if ($row["o_type"] != $T_PAGE) continue;
 
 $page = get_pageinfo($row["o_id"]);
 if (!$page) continue;
 
 $folder = get_folderinfo($page["folder_id"]);
 if (!$folder["node_id"]) continue;
 if (!$CN_MAP->doPublishContentmap($folder["node_id"])) continue;
 if ($CN_MAP->getNodeHandleKey($folder["node_id"]) != $mapKey) continue;
 
 $pdate = $page["pdate"]; 
 if ( $pdate < $row["mt"] ) continue;
 
 $event = $row["cmd_desc_id"];
 $NOTIFICATION_TABLE = $CN_MAP->getCnMapNotificationTable($folder["node_id"]);
 $NOTIFY_DB = $CN_MAP->getNotificationHandle($folder["node_id"]);
 
 if ( !$CN_MAP->doPublishNotificationQueueByKey($mapKey) ) {
 $sql = "DELETE FROM ".sqlf_table($NOTIFICATION_TABLE)." WHERE CONTENTID='".sqlf_escaped($contentid)."'";
 query( $sql, $NOTIFY_DB );
 }
 $fedate = date("Y/m/d H:i:s", $pdate);
 $dateformat = "YYYY/MM/DD HH24:MI:SS";
 
 
 $sql = "INSERT INTO ".sqlf_table($NOTIFICATION_TABLE)." (CONTENTID,LASTMODIFIED,EVENT) VALUES ".
 "('".sqlf_escaped($contentid)."', to_date( '".sqlf_escaped($fedate)."', '".sqlf_escaped($dateformat)."' ), ".sqlf_tl_num($event)." )";
 query( $sql, $NOTIFY_DB );
 }
 }
}

function publish_folder() {

 global $T_FOLDER, $CN_MAP, $PUBWAY, $SKIP_PUBLISH_FOLDERS, $CONTENTMAP_LASTDUR, $CONTENTMAP_ACTDUR, $WRITEFS_LASTDUR, $PAGES_ETA;
 $PUBWAY = "stat";

 if ( $SKIP_PUBLISH_FOLDERS ) return;
 
 $maps = $CN_MAP->getConfigurations();
 
 
 $counter_contentmap = 0;
 $counter_update = 0;

 $t_start = microtime ();

 $eta = $CONTENTMAP_LASTDUR["folder"][0] + $CONTENTMAP_LASTDUR["files"][0] + $CONTENTMAP_LASTDUR["delete"][0] + $WRITEFS_LASTDUR["sum"] + $PAGES_ETA;
 $eta = round ($eta);

 $sql = "UPDATE nodesetup SET intvalue = ".sqlf_tl_num($eta)." WHERE name = 'publish_eta'";
 query ($sql);

 foreach ($maps as $mapKey=>$val) {

 $counter_contentmap++;

 
 $lastupdate = get_lastmapupdate($mapKey);
 $handle = $CN_MAP->getNodeHandleByKey($mapKey);
 
 $t_start_sql = microtime ();
 
 



 
 
 $nodesArr = explode(',', getPublishNodeIdSet());
 while (list($key,$nodeId)=each($nodesArr)) {
 $lastupdateNode = getLastPublishByNodeId($nodeId);
 if (!$lastupdateNode) $lastupdateNode = $lastupdate; 
 
 if ( $lastupdateNode ) {
 $sql = "SELECT folder.id,
						folder.mother,
						folder.node_id
					FROM folder,
						logcmd,
						node
					WHERE logcmd.o_id=folder.id AND
						logcmd.timestamp > ".sqlf_tl_num($lastupdateNode)." AND
						logcmd.o_type = ".sqlf_tl_num($T_FOLDER)." AND
						logcmd.cmd_desc_id IN (".implode(",",sqlf_tl_num_array(get_object_changeing_commands())).") AND
						node.id = folder.node_id AND
						node.publish_contentmap = 1 AND
						node.contentmap_handle = \"".sqlslashes($handle)."\" AND
						folder.node_id = ".sqlf_tl_num($nodeId)."
					GROUP BY folder.id";
 } else {
 $sql = "SELECT folder.id,
						folder.mother,
						folder.node_id
					FROM folder,
						node
					WHERE node.id = folder.node_id AND
						node.publish_contentmap = 1 AND
						node.contentmap_handle = \"".sqlslashes($handle)."\" AND
						node.id = ".sqlf_tl_num($nodeId);
 }
 
 $rs = appendRS($rs, query($sql));
 }
 $time_sql += calctime ($t_start_sql, microtime (), 5);
 
 $eta = $time_sql / $counter_contentmap * (count ($maps) - $counter_contentmap + 1) 
 + $rs["num"] * $CONTENTMAP_LASTDUR["folder"][2] * (count ($maps) - $counter_contentmap + 1) 
 + $CONTENTMAP_LASTDUR["files"][0] + $CONTENTMAP_LASTDUR["delete"][0] + $WRITEFS_LASTDUR["sum"] + $PAGES_ETA;

 $eta = round($eta);
 $sql = "UPDATE nodesetup SET intvalue = ".sqlf_tl_num($eta)." WHERE name = 'publish_eta'";
 query ($sql);

 global $LOG_FP;
 log_publish($LOG_FP, "\nFolders to publish: ".$rs["num"]."\n");
 foreach($rs["arr"] as $row) {

 $t_start_update = microtime ();
 $counter_update++;
 
 $tmp = Array();
 $tmp["id"] = $row["id"];
 $tmp["type"] = $T_FOLDER;
 $tags = obj_translate($tmp,"obj");

 update_contentmap($row["id"],$T_FOLDER,$row["mother"],$T_FOLDER,$row["node_id"],$tags);

 $time_update += calctime ($t_start_update, microtime (), 5);

 
 if ($counter_update % 5 == 0)
 {
 $eta = $time_update / $counter_update * ($rs["num"] - $counter_update) 
 + (count ($maps) - $counter_contentmap) * $time_update / $counter_update 
 + $time_sql / $counter_contentmap * (count ($maps) - $counter_contentmap + 1) 
 + $CONTENTMAP_LASTDUR["files"][0] + $CONTENTMAP_LASTDUR["delete"][0] + $WRITEFS_LASTDUR["sum"] + $PAGES_ETA;

 $eta = round ($eta);
 $sql = "UPDATE nodesetup SET intvalue = ".sqlf_tl_num($eta)." WHERE name = 'publish_eta'";
 query ($sql);
 }
 }
 }
 $PUBWAY = "dyn";

 
 $CONTENTMAP_ACTDUR["folder"][0] = calctime ($t_start, microtime (), 5);
 $CONTENTMAP_ACTDUR["folder"][1] = $time_sql / count ($maps);

 if ($counter_update)
 $CONTENTMAP_ACTDUR["folder"][2] = $time_update / $counter_update;
 else
 $CONTENTMAP_ACTDUR["folder"][2] = $CONTENTMAP_LASTDUR["folder"][2];
}

function publish_files() {
 global $T_FILE, $T_IMAGE, $CN_MAP, $T_FOLDER, $PUBWAY, $SKIP_PUBLISH_FILES, $FEATURE, $CONTENTMAP_LASTDUR, $CONTENTMAP_ACTDUR, $WRITEFS_LASTDUR,
 $PAGES_ETA;
 
 if ( $SKIP_PUBLISH_FILES ) return;
 $PUBWAY = "stat";

 $maps = $CN_MAP->getConfigurations();

 
 $counter_contentmap = 0;
 $counter_update = 0;

 $t_start = microtime ();

 $eta = $CONTENTMAP_LASTDUR["files"][0] + $CONTENTMAP_LASTDUR["delete"][0] + $WRITEFS_LASTDUR["sum"] + $PAGES_ETA;
 $eta = round ($eta);

 $sql = "UPDATE nodesetup SET intvalue = ".sqlf_tl_num($eta)." WHERE name = 'publish_eta'";
 query ($sql);
 
 foreach ($maps as $mapKey=>$val) {
 
 $counter_contentmap++;
 
 $lastupdate = get_lastmapupdate($mapKey);
 $handle = $CN_MAP->getNodeHandleByKey($mapKey);

 $t_start_sql = microtime ();
 
 



 
 
 $nodesArr = explode(',', getPublishNodeIdSet());
 while (list($key,$nodeId)=each($nodesArr)) {
 $lastupdateNode = getLastPublishByNodeId($nodeId);
 if (!$lastupdateNode) $lastupdateNode = $lastupdate; 
 
 if ($lastupdateNode) {
 





 $sql = "SELECT logcmd.cmd_desc_id,
						contentfile.id,
						contentfile.folder_id,
						folder.node_id
					FROM contentfile,
						logcmd,
						folder,
						node
					WHERE logcmd.o_id=contentfile.id AND
						folder.id = contentfile.folder_id AND
						logcmd.timestamp > ".sqlf_tl_num($lastupdateNode)." AND
						(logcmd.o_type=".sqlf_tl_num($T_FILE)." OR logcmd.o_type=".sqlf_tl_num($T_IMAGE).") AND
						logcmd.cmd_desc_id IN (".implode(",",sqlf_tl_num_array(get_object_changeing_commands())).") AND
						node.id = folder.node_id AND
						node.publish_contentmap = 1 AND
						node.contentmap_handle = \"".sqlslashes($handle)."\" AND
						node.id = ".sqlf_tl_num($nodeId)."
					GROUP BY contentfile.id";
 } else {
 $sql = "SELECT contentfile.id,
						contentfile.folder_id,
						folder.node_id
					FROM contentfile,
						folder,
						node
					WHERE folder.id = contentfile.folder_id AND
						node.id = folder.node_id AND
						node.publish_contentmap = 1 AND
						node.contentmap_handle = \"".sqlslashes($handle)."\" AND
						node.id = ".sqlf_tl_num($nodeId);
 }
 
 $rs = appendRS($rs, query($sql));
 } 
 $time_sql += calctime ($t_start_sql, microtime (), 5);

 $eta = $time_sql / $counter_contentmap * (count ($maps) - $counter_contentmap + 1) 
 + $rs["num"] * $CONTENTMAP_LASTDUR["files"][2] * (count ($maps) - $counter_contentmap + 1) 
 + $CONTENTMAP_LASTDUR["delete"][0] + $WRITEFS_LASTDUR["sum"] + $PAGES_ETA;

 $eta = round ($eta);
 $sql = "UPDATE nodesetup SET intvalue = ".sqlf_tl_num($eta)." WHERE name = 'publish_eta'";
 query ($sql);
 
 global $LOG_FP;
 log_publish($LOG_FP, "\nFiles to publish: ".$rs["num"]."\n");
 foreach($rs["arr"] as $row) {

 $t_start_update = microtime ();
 $counter_update++;

 if ($lastupdate) {
 $sql = "SELECT count(*) AS c FROM logcmd WHERE (o_type = ".sqlf_tl_num(CT_FILE)." OR o_type = ".sqlf_tl_num(T_IMAGE).") AND o_id = ".sqlf_tl_num($row["id"])." AND cmd_desc_id IN (".sqlf_tl_num(W_EDIT).",".sqlf_tl_num(W_CREATE).") AND logcmd.timestamp > ".sqlf_tl_num($lastupdate);
 $rs2 = query($sql);
 $publishbin = $rs2["arr"][0]["c"];
 } else $publishbin = false;
 
 $tmp = Array();
 $tmp["id"] = $row["id"];
 $tmp["type"] = $T_FILE;
 $tags = obj_translate($tmp,"obj");
 $tmp["id"] = $row["folder_id"];
 $tmp["type"] = $T_FOLDER;
 $foldertags = obj_translate($tmp,"obj",$row["id"],"file" ,$row["node_id"]);
 if (!$foldertags) $foldertags = array();
 if (!$tags) $tags = array();
 $cmd_desc_id = $row["cmd_desc_id"];

 $_meta = Array();
 $excluded = Array();
 if ( $CN_MAP->doPublishFiles($row["node_id"]) && ($publishbin || !$lastupdate)) {
 global $FILEPATH;
 $fname = $FILEPATH."/content/dbfiles/".$row["id"].".bin";
 $fsize= filesize($fname);
 $fp = fopen( $fname, "rb" );
 $content = fread($fp,$fsize);
 fclose( $fp );
 $_meta["binarycontent"] = $content;
 } else {
 $excluded[] = "binarycontent";
 }
 update_contentmap($row["id"],$T_FILE,$row["folder_id"],$T_FOLDER,$row["node_id"],$tags + $foldertags, $_meta, $excluded);

 $time_update += calctime ($t_start_update, microtime (), 5);

 
 if ($counter_update % 5 == 0)
 {
 $eta = $time_update / $counter_update * ($rs["num"] - $counter_update) 
 + (count ($maps) - $counter_contentmap) * $time_update / $counter_update 
 + $time_sql / $counter_contentmap * (count ($maps) - $counter_contentmap + 1) 
 + $CONTENTMAP_LASTDUR["delete"][0] + $WRITEFS_LASTDUR["sum"] + $PAGES_ETA;
 
 $eta = round ($eta);
 $sql = "UPDATE nodesetup SET intvalue = ".sqlf_tl_num($eta)." WHERE name = 'publish_eta'";
 query ($sql);
 }
 }
 }
 $PUBWAY = "dyn";

 
 $CONTENTMAP_ACTDUR["files"][0] = calctime ($t_start, microtime (), 5);
 $CONTENTMAP_ACTDUR["files"][1] = $time_sql / count ($maps);

 if ($counter_update)
 $CONTENTMAP_ACTDUR["files"][2] = $time_update / $counter_update;
 else
 $CONTENTMAP_ACTDUR["files"][2] = $CONTENTMAP_LASTDUR["files"][2];
}

function publish_sync_deleted() {
 global $W_PAGETIME, $CN_MAP, $CONTENTMAP_LASTDUR, $CONTENTMAP_ACTDUR, $WRITEFS_LASTDUR, $PAGES_ETA, $T_PAGE, $T_FOLDER, $T_FILE;
 
 $maps = $CN_MAP->getConfigurations();

 
 $counter_contentmap = 0;
 $counter_update = 0;

 $t_start = microtime ();

 $eta = $CONTENTMAP_LASTDUR["delete"][0] + $WRITEFS_LASTDUR["sum"] + $PAGES_ETA;
 $eta = round ($eta);

 $sql = "UPDATE nodesetup SET intvalue = ".sqlf_tl_num($eta)." WHERE name = 'publish_eta'";
 query ($sql);
 
 foreach ($maps as $mapKey=>$v) {

 $counter_contentmap++;
 
 if ( ! ( $lastupdate = get_lastmapupdate($mapKey) ) ) continue;
 $db = $CN_MAP->getCnMapHandleByKey($mapKey);
 
 $t_start_sql = microtime ();
 
 $sql = "SELECT DISTINCT o_type, o_id FROM logcmd WHERE timestamp > ".sqlf_tl_num($lastupdate)." AND cmd_desc_id=".sqlf_tl_num(W_DEL)." AND (o_type = ".sqlf_tl_num($T_FILE)." OR o_type = ".sqlf_tl_num($T_FOLDER)." OR o_type = ".sqlf_tl_num($T_PAGE).")";
 $rs = query( $sql );

 $time_sql += calctime ($t_start_sql, microtime (), 5);

 $eta = $time_sql / $counter_contentmap * (count ($maps) - $counter_contentmap + 1) 
 + $rs["num"] * $CONTENTMAP_LASTDUR["files"][2] * (count ($maps) - $counter_contentmap + 1) 
 + $WRITEFS_LASTDUR["sum"] + $PAGES_ETA;
 
 $eta = round ($eta);
 $sql = "UPDATE nodesetup SET intvalue = ".sqlf_tl_num($eta)." WHERE name = 'publish_eta'";
 query ($sql);
 
 foreach ( $rs["arr"] as $row )
 {
 $t_start_update = microtime ();
 $counter_update++;
 
 delete_content_object( $row["o_type"], $row["o_id"], $db );
 
 $time_update += calctime ($t_start_update, microtime (), 5);

 
 if ($counter_update % 5 == 0)
 {
 $eta = $time_update / $counter_update * ($rs["num"] - $counter_update) 
 + (count ($maps) - $counter_contentmap) * $time_update / $counter_update 
 + $time_sql / $counter_contentmap * (count ($maps) - $counter_contentmap + 1) 
 + $WRITEFS_LASTDUR["sum"] + $PAGES_ETA;

 $eta = round ($eta);
 $sql = "UPDATE nodesetup SET intvalue = ".sqlf_tl_num($eta)." WHERE name = 'publish_eta'";
 query ($sql);
 }
 }

 
 $sql = "SELECT DISTINCT logcmd.o_type, logcmd.o_id, node.disable_publish, folder.node_id FROM logcmd ".
 " LEFT JOIN page ON logcmd.o_type = ".sqlf_tl_num(T_PAGE).
 "      AND logcmd.o_id = page.id ".
 " LEFT JOIN contentfile ON logcmd.o_type IN (".sqlf_tl_num(CT_FILE).','.sqlf_tl_num(T_IMAGE).") AND logcmd.o_id = contentfile.id ".
 " LEFT JOIN folder AS folderobj ON logcmd.o_type = ".sqlf_tl_num(T_FOLDER)." AND logcmd.o_id = folderobj.id ".
 " INNER JOIN folder ON folder.id = page.folder_id OR folder.id = contentfile.folder_id OR folder.id = folderobj.id ".
 " INNER JOIN node ON node.id = folder.node_id WHERE logcmd.cmd_desc_id = ".sqlf_tl_num(W_MOVE).
 " AND logcmd.timestamp > ".sqlf_tl_num($lastupdate);
 $rs = query( $sql );
 foreach ( $rs['arr'] as $row ) {
 if (!$row['disable_publish']) continue;
 delete_content_object( $row["o_type"], $row["o_id"], $db, 'Moved into node which has publishing disabled.' );
 }
 
 
 $sql = "SELECT DISTINCT logcmd.o_type, logcmd.o_id, folder.node_id FROM page, logcmd, folder WHERE page.id=logcmd.o_id ".
 "AND logcmd.o_type=".sqlf_tl_num(T_PAGE)." AND logcmd.cmd_desc_id IN (".sqlf_tl_num(W_PAGEOFFLINE).",".sqlf_tl_num($W_PAGETIME).") ".
 " AND logcmd.timestamp > ".sqlf_tl_num($lastupdate)." AND page.status IN (".sqlf_tl_num(PAGE_STATUS_OFFLINE).",5)".
 " AND folder.id = page.folder_id";
 $rs = query( $sql );
 foreach ( $rs["arr"] as $row )
 {
 if ($CN_MAP->getNodeHandleKey($row["node_id"]) != $mapKey) continue;
 delete_content_object( $row["o_type"], $row["o_id"], $db );
 }
 }

 
 $CONTENTMAP_ACTDUR["delete"][0] = calctime ($t_start, microtime (), 5);
 $CONTENTMAP_ACTDUR["delete"][1] = $time_sql / count ($maps);
 
 if ($counter_update)
 $CONTENTMAP_ACTDUR["delete"][2] = $time_update / $counter_update;
 else
 $CONTENTMAP_ACTDUR["delete"][2] = $CONTENTMAP_LASTDUR["delete"][2];
}

function publish_queue($type = "", $repub_pages = NULL) {

 global $PPT, $LOG, $LOG_FP, $MAXPAGEPUBTIME, $FEATURE, $TS_STATUS_RESET, $WRITEFS_LASTDUR, $TS, $DEBUG;

 $t1 = microtime();

 static $REPUB_PAGES = array();
 static $page_time_all = 0;
 static $pages_published_all = 0;

 if( $repub_pages !== NULL && is_array( $repub_pages ) && is_array( $REPUB_PAGES ) ) {
 $REPUB_PAGES = array_merge( $REPUB_PAGES, $repub_pages );
 }

 if ($type == "all") $limit = 0;
 else if ($type == "repub") { $limit = 0; $skip_status = true; }
 else $limit = 10;

 if ($type == "all") {
 
 
 
 $sql = "UPDATE publish LEFT JOIN page ON publish.page_id = page.id ".
 "LEFT JOIN folder ON page.folder_id = folder.id ".
 "LEFT JOIN node ON folder.node_id = node.id ".
 "SET active = 0 WHERE node.disable_publish = 1 AND publish.node_id != node.id";
 query($sql);
 }

 if ($type == "all" && !$FEATURE["keep_published_pages"]) {
 $sql = "DELETE FROM publish WHERE active = 0";
 query($sql);
 }

 
 $TS_STATUS_RESET = 0;
 
 
 if ($type == "all" && $FEATURE["republish_pages"] && $FEATURE["republish_marked_only"] && is_array ($REPUB_PAGES))
 {
 $ids = implode (", ", sqlf_tl_num_array($REPUB_PAGES));

 if ($ids)
 $sql_and = " AND page.id IN ($ids)";
 else
 $sql_and = " AND 1=0";

 
 $TS_STATUS_RESET = time();

 } else {
 $sql_and = "";
 }

 



 
 $sql = find_publish_pages_sql( $sql_and );
 
 $rs = query($sql,false,$limit);

 $REPUB_PAGES = array();

 $num = 0;

 $outp = "pages to publish: ".$rs["num"]."\n";
 log_publish($LOG_FP, $outp);

 if ($rs["arr"]) {
 $number_pages = $rs["num"];
 $pages_published = 0;
 $page_time = 0;
 $avg_page_time = 0;

 while (list($key,$row) = each($rs["arr"])) {
 if ($FEATURE["log_publish_page_filename"]) {
 $sql = "SELECT filename FROM page WHERE id = ".sqlf_tl_num($row["id"]);
 $rs_fname = query($sql);

 $outp = "page ".$row["id"]."\t".$rs_fname["arr"][0]["filename"]."\t";
 }
 else
 $outp = "page ".$row["id"]."\t";
 
 log_publish($LOG_FP, $outp);

 set_time_limit($MAXPAGEPUBTIME);
 $sql = "SELECT count(id) AS c FROM page WHERE id = ".sqlf_tl_num($row["id"]);
 $rs_tmp = query($sql);
 if ($rs_tmp["arr"][0]["c"] == 0) {
 $number_pages--;
 continue;
 }

 cmd_page_settimestate($row["id"]);

 $pt1 = microtime();

 $num++;
 $retval = true;
 if (!$PPT[$row["id"]]) {
 $retval = publish_page($row["id"], $skip_status);
 }

 
 $pt2 = microtime();
 $TS["sum_publish_page"] += calctime($pt1,$pt2,12);
 $TS["sum_publish_page_invocations"] += 1;
 $PPT[$row["id"]] = calctime($pt1, $pt2, 5);

 
 $page_time += $PPT[$row["id"]];
 $avg_page_time = $page_time / ++$pages_published;
 $number_pages--;

 $outp = "(".$PPT[$row["id"]].")\t";
 if (!$retval) {
 $outp .= " needs republish";
 unset($PPT[$row["id"]]);

 $REPUB_PAGES[] = $row["id"];
 }
 $outp .= "\n";
 log_publish($LOG_FP, $outp);

 $eta = ($number_pages + count($REPUB_PAGES)) * $avg_page_time;
 $eta += $WRITEFS_LASTDUR["sum"];
 $eta = round ($eta);

 $sql = "UPDATE nodesetup SET intvalue = ".sqlf_tl_num($eta)." where name = 'publish_eta'";
 query ($sql);
 }

 $page_time_all += $page_time;
 $pages_published_all += $pages_published;

 
 $tmp = round ($page_time_all / $pages_published_all, 2);
 $sql = "UPDATE nodesetup SET textvalue = '".sqlf_escaped($tmp)."' WHERE name = 'publish_pages_lastdur'";
 query ($sql);
 }

 $LOG["publish_queue"] = $outp;

 $t2 = microtime();

 return $num;

}

function find_publish_pages_sql($sql_and = '', $sql_join = '') {
 $sql = 'SELECT page.id
	FROM page INNER JOIN folder ON page.folder_id = folder.id '.$sql_join.'
	WHERE page.status = 1 AND
		folder.node_id IN (' . getPublishNodeIdSet() . ') ' .
 $sql_and;
 return $sql;
}

function logdetailtime($timing) {
 global $DEBUG, $LOG_FP;
 if ( $DEBUG["publish_time"] )
 {
 $prev = 0;
 $outp = "";
 foreach ( $timing as $tname=>$time )
 {
 if ( $prev != 0 )
 {
 $outp .= $tname."(".calctime($prev,$time,2)."),";
 }
 $prev = $time;
 $outp = substr($outp,0,-1)."\n";
 }
 }
 else
 {
 $outp = "(".calctime($timing["begin"],$timing["end"],3).")";
 }

 if ( $LOG_FP ) {
 log_publish($LOG_FP, $outp);
 }
}










 
function getPublishNodeIdSet() {
 global $NODE_PUB_IDSET;
 
 if ($NODE_PUB_IDSET) return $NODE_PUB_IDSET;
 $sql = 'SELECT id FROM node WHERE disable_publish = 0';
 $rs = query($sql);
 
 if ($rs['num'] == 0) return $NODE_PUB_IDSET = -1;
 while (list($key,$val)=each($rs['arr'])) {
 $tmpArr[] = sqlf_tl_num($val['id']);
 }
 
 return $NODE_PUB_IDSET = implode(',',$tmpArr);
}










 
function getLastPublishByNodeId($nodeId) {
 global $W_PAGEPUB, $T_NODE;
 $sql = "SELECT timestamp
	FROM logcmd
	WHERE cmd_desc_id = ".sqlf_tl_num($W_PAGEPUB)." AND
		o_type = ".sqlf_tl_num($T_NODE)." AND
		o_id = ".sqlf_tl_num($nodeId)."
	ORDER BY timestamp DESC
	LIMIT 1";
 $rs = query($sql);
 if ($rs['num'] == 0) return false;
 return $rs['arr'][0][0];
}












function appendRS($a,$b) {
 if ($a['num'] == 0 && $b['num'] == 0) return $b;
 if ($a['num'] == 0) return $b;
 if ($b['num'] == 0) return $a;
 $a['num'] += $b['num'];
 $a['arr'] = array_merge($a['arr'],$b['arr']);
 return $a;
}


?>
