<?

function touch_objprop ($obj_type, $obj_id, $page_id = 0, $enabled = 0) {

 global $FEATURE, $DEBUG, $T_PAGE, $T_TEMPLATE, $T_FOLDER;

 if( !$obj_type ) {
 warning(20, 'touch_objprop: Error, obj_type is not defined.' );
 return FALSE;
 }

 $restrictedTo = getObjtagsForObject($obj_type, $obj_id);
 if ($DEBUG['objprop']) echo "Restricted to:".count($restrictedTo)."<br>";
 if ( count($restrictedTo) > 0) {
 $restrictSQL = "AND objtag.id in (".implode(",",sqlf_tl_num_array($restrictedTo)).")";
 } else {
 $restrictSQL = "AND 1 = 2";
 }

 
 if ($FEATURE['template_objprop'] && $obj_type == $T_PAGE) {
 
 if (!$page_id) {
 warning(7,"touch_objprop: page_id may not be 0 page_id ($page_id)");
 return false;
 }
 
 $page = get_pageinfo($page_id);
 $sql = "SELECT DISTINCT objtag.name, objtag.construct_id, construct.icon, objtag.inpage, 
		LOWER(objtag.name) AS l_name, objtag.required, objtag.inheritable
		FROM objtag, construct
		WHERE (
			(objtag.obj_type = ".sqlf_tl_num($obj_type)." AND objtag.obj_id = 0 $restrictSQL) 
			OR 
			(
			  objtag.inpage = 1 AND
			  (
			    (objtag.obj_type = ".sqlf_tl_num($T_TEMPLATE)." AND objtag.obj_id = ".sqlf_tl_num($page['template_id']).".) 
			    OR 
			    (objtag.obj_type = ".sqlf_tl_num($T_FOLDER)." AND objtag.obj_id = ".sqlf_tl_num($page['folder_id']).")
			  ) 
			)
		      )
		AND objtag.construct_id = construct.id ORDER BY l_name";
 } else {
 $sql = "SELECT objtag.id, objtag.name, objtag.construct_id, construct.icon, objtag.inpage,
		LOWER(objtag.name) AS l_name, objtag.required, objtag.inheritable
		FROM objtag, construct 
		WHERE objtag.obj_type = ".sqlf_tl_num($obj_type)." AND objtag.obj_id = 0 AND objtag.construct_id = construct.id $restrictSQL ORDER BY l_name";
 }
 
 if ($DEBUG['objprop']) echo "Get editable properities<br>$sql<br>";
 
 $rs = query($sql);
 $o_props = $rs["arr"];

 $changed_objprops = false;
 
 if (is_array($o_props))
 while (list($key,$val) = each($o_props)) {
 
 
 $sql = "SELECT id, construct_id, name FROM objtag 
		WHERE obj_type = ".sqlf_tl_num($obj_type)." AND obj_id = ".sqlf_tl_num($obj_id)." AND name = '".sqlf_escaped($val["name"])."'";
 
 if ($DEBUG['objprop']) echo "Getting tag defs for checking<br>$sql<br>";
 
 $rs = query($sql);
 
 if ($rs["num"] > 0 && $rs["arr"][0]["construct_id"] != $val["construct_id"]) {
 tag_del($rs["arr"][0]["id"],"obj");
 $changed_objprops = true;
 if ($DEBUG['objprop']) echo "Renew that tag<br>";
 $renew = true;
 } else {
 $renew = false;
 }
 if ($rs["num"] == 0 || $renew) {
 $sql = "INSERT INTO objtag (obj_type, obj_id, name, construct_id, enabled, required, inpage, inheritable) 
			VALUES (".sqlf_tl_num($obj_type).", ".sqlf_tl_num($obj_id).", '".sqlf_escaped($val["name"])."', ".sqlf_tl_num($val["construct_id"]).", ".sqlf_tl_num((int)$enabled).", ".sqlf_tl_num($val["required"]).", ".sqlf_tl_num($val['inpage']).", ".sqlf_tl_num($val['inheritable']).")";
 if ($DEBUG['objprop']) echo "Inserted because existing=(".$rs['num'].") or renew=($renew)<br>$sql<hr>";
 $rs = query($sql);
 $changed_objprops = true;
 }
 }

 
 if ($changed_objprops) {
 if ($FEATURE["javaparser"]) {
 $javaParser =& CodeParser::getJavaParser();
 $javaParser->clearCache($obj_type, $obj_id);
 }
 }
}







function getObjtagsForObject($obj_type, $obj_id) {
 global $DEBUG, $FEATURE;

 switch($obj_type) {
 case 10002:
 $lookup_id = $obj_id;
 if ($FEATURE["multichannelling"]) {
 
 $folderinfo = get_folderinfo($obj_id);
 if ($folderinfo["mother"] == 0 && $folderinfo["master_id"] != 0) {
 $master_nodeid = getMasterNode($folderinfo[channel_id], true);
 $master_nodeinfo = get_nodeinfo($master_nodeid);
 $lookup_id = $master_nodeinfo["folder_id"];
 }
 }
 $sql = "select node_id from folder where id = ".sqlf_tl_num($lookup_id);
 $rs = query($sql);
 if ($rs["num"] > 0) {
 $nodes = $rs["arr"][0]["node_id"];
 }
 break;
 case 10006:
 $sql = "select folder.node_id from template_folder inner join folder on template_folder.folder_id = folder.id 
				where template_folder.template_id = ".sqlf_tl_num(getMasterTemplateId($obj_id)) . " 
				GROUP BY folder.node_id";
 $rs = query($sql);
 if ($rs["num"] > 0) {
 $nodes = array();
 while( list($k, $row) = each($rs["arr"])) {
 $nodes[] = $row["node_id"];
 }
 }
 break;
 case 10007:
 $sql = "select folder.node_id from page left join folder on page.folder_id = folder.id where page.id = ".sqlf_tl_num($obj_id);
 $rs = query($sql);
 if ($rs["num"] > 0) {
 $nodes = $rs["arr"][0]["node_id"];
 }
 break;
 case 10008:
 case 10011:
 $sql = "select folder.node_id from contentfile left join folder on contentfile.folder_id = folder.id where contentfile.id = ".sqlf_tl_num($obj_id);
 $rs = query($sql);
 if ($rs["num"] > 0) {
 $nodes = $rs["arr"][0]["node_id"];
 }
 break;
 }

 if (!$nodes) {
 return;
 }

 if (is_array($nodes)) {
 $nodeIdList = implode(",",sqlf_tl_num_array($nodes));
 } else {
 $nodeIdList = sqlf_tl_num($nodes);
 }

 $sql = "select distinct objtag.id from objtag left join objprop on objtag.id = objprop.objtag_id left join objprop_node on objprop.id = objprop_node.objprop_id where objtag.obj_id = 0 and objtag.obj_type = ".sqlf_tl_num($obj_type)." and (objprop_node.node_id in (".$nodeIdList.") or objprop_node.node_id is null)";
 if ($DEBUG['objprop']) echo "Checking Objtags for nodes: $nodeIdList with<br/>$sql<br/>";
 $rs = query($sql);
 $objtagIds = array();

 while (list($k, $row) = each($rs["arr"])) {
 $objtagIds[] = $row["id"];
 }

 return $objtagIds;
}

?>
